package com.focustech.baseandroid.adapter;


import com.focustech.baseandroid.db.bean.DBean;

import android.content.Context;
import android.view.View;

/**
 * 对于从数据库查找的数据，构建出来的Adapter如果数据较少的情况下，可以将数据全部初始化完成
 * 在进行创建Adapter，但是假如查找出来的数据较多，假设是10000条，界面将会出现假死的情况
 * 对于这种情况，可以使用BaseDbAdapter 读取需要位置的数据，而不是全部读取出来。
 * @author zhangzheng
 *
 * @param <T> DBean的子类
 */
public abstract class BaseDbAdapter<T extends DBean> extends AbsBasicAdapter<T,DBean>{

	public BaseDbAdapter(Context context, T bean) {
		super(context, bean);
	}


	@Override
	protected View initItemViewData(int position, T data, View convertView) {
		cursor.moveToPosition(position);
		data.fillData(cursor);
		return initDbItemViewData(position,data,convertView);
	}
	
	protected abstract View initDbItemViewData(int position, T data, View convertView);

}
