package com.focustech.baseandroid.bean;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Set;

import android.os.Bundle;

/**
 * 记录意图信息的Bean 用户记录每一次意图请求
 * 
 * @author zhangzheng
 * 
 */
public class IntentBean extends BaseBean implements Serializable {

	private String claName;
	private Integer requestCode;
	private HashMap<String, Object> map;

	public String getClaName() {
		return claName;
	}

	public void setClaName(String claName) {
		this.claName = claName;
	}

	public Integer getRequestCode() {
		return requestCode;
	}

	public void setRequestCode(Integer requestCode) {
		this.requestCode = requestCode;
	}

	public Bundle getBundler() {
		Bundle bundler = new Bundle();
		Set<String> keySet = map.keySet();
		for (String key : keySet) {
			Object value = map.get(key);
			if (value instanceof String) {
				bundler.putString(key, (String) value);
			} else if (value instanceof Integer) {
				bundler.putInt(key, (int) value);
			} else if (value instanceof Double) {
				bundler.putDouble(key, (double) value);
			} else if (value instanceof Float) {
				bundler.putFloat(key, (float) value);
			} else if (value instanceof Boolean) {
				bundler.putBoolean(key, (boolean) value);
			} else if (value instanceof Serializable) {
				bundler.putSerializable(key, (Serializable) value);
			}
		}
		return bundler;
	}

	public void setBundler(Bundle bundler) {
		HashMap<String, Object> map = new HashMap<>();
		Set<String> keySet = bundler.keySet();
		for (String key : keySet) {
			Object value = bundler.get(key);
			map.put(key, value);
		}
		this.map = map;
	}

}
