package com.focustech.baseandroid.bean.interfaces;

import android.content.ContentValues;
import android.database.Cursor;

import com.focustech.baseandroid.bean.BaseBean;

/**
 * 基础BaseBean的接口对象，之后每一个高级功能的数据模型类，实现的接口需要 继承该接口
 * @author zhangzheng
 *
 */
public interface BaseBeanInterFace {
	/**
	 * 转换字符串的null值为空值("")
	 */
	public void conversionStringNull();

	/**
	 * 复制一个
	 * @return
	 */
	public <T extends BaseBeanInterFace> T copy();

	/**
	 * 填充数据
	 * @param bean
	 * @return
	 */
	public <T extends BaseBean> T fillData(T bean);
	
	/**
	 * 根据游标填充自己
	 * @param query
	 */
	public void  fillData(Cursor query);
	
	
	/**
	 * 获得数据库操作存储对象ContentValues
	 * @return
	 */
	public ContentValues getContentValues();
	
	/**
	 * 变成JSON数据
	 * @return
	 */
	public String toJSONString();

	/**
	 * JSON数据填充自己
	 * @param json
	 */
	public boolean parseJsonToBean(String json);
	
	/**
	 * 保存数据到本地
	 * @param key
	 */
	public void saveLocation(String key);
	
	/**
	 * 从本地的缓存填充自己
	 * @param key
	 */
	public boolean fillDataFromLocation(String key);
}
