package com.focustech.baseandroid.manager;

import java.util.ArrayList;
import java.util.List;

import com.focustech.baseandroid.listener.OnLifeCycleChangeListener;
import com.focustech.baseandroid.listener.OnLifeCycleChangeListener.LifeCycle;

/**
 * 生命周期的管理类
 * @author zhangzheng
 *
 */
public class LifeCycleManager {
	
	private List<OnLifeCycleChangeListener> listeners;

	public LifeCycleManager() {
		listeners = new ArrayList<>();
	}

	public void notifyLifeCycleChange(LifeCycle cl) {
		for (OnLifeCycleChangeListener lis : listeners) {
			lis.onChange(cl);
		}
	}

	public void registerLifeCycle(OnLifeCycleChangeListener lis) {
		if (!listeners.contains(lis)) {
			listeners.add(lis);
		}
	}

}
