package com.focustech.baseandroid.manager;

import java.lang.Thread.UncaughtExceptionHandler;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.SystemClock;

import com.focustech.baseandroid.BaseApp;
import com.focustech.baseandroid.general.BaseAnnotation.isCatchException;
import com.focustech.baseandroid.listener.OnLifeCycleChangeListener.LifeCycle;

public class UnCeManager implements UncaughtExceptionHandler {

	public static final String TAG = "CatchExcep";
	BaseApp application;
	private final isCatchException annotation;

	public UnCeManager(BaseApp application, isCatchException annotation) {
		this.application = application;
		this.annotation = annotation;
	}

	@Override
	public void uncaughtException(Thread thread, Throwable ex) {
		LifeCycle life = application.currenActivityLife();
		if (life != null && life != LifeCycle.ONCREATE
				&& life != LifeCycle.START&&annotation.recovery()) {
			Intent intent = new Intent(application.getApplicationContext(),
					application.getFirstActivity().getClass());
			String currenTime = SystemClock.currentThreadTimeMillis() + "";

			intent.putExtra("exceptionTime", currenTime);
			application.saveIntentRecodeLocal(currenTime);

			PendingIntent restartIntent = PendingIntent.getActivity(
					application.getApplicationContext(), 0, intent,
					Intent.FLAG_ACTIVITY_NEW_TASK);
			// 退出程序
			AlarmManager mgr = (AlarmManager) application
					.getSystemService(Context.ALARM_SERVICE);
			mgr.set(AlarmManager.RTC, System.currentTimeMillis() + 1000,
					restartIntent); // 1秒钟后重启应用
		}
		application.remoteAllFinish();
	}
}
