package com.focustech.baseandroid.net;

import com.focustech.baseandroid.net.params.Result;
import com.focustech.baseandroid.net.params.Url;


/**
 * 请求构造类
 * 
 * @author zhangzheng
 *
 * @param <T>
 */
class Builder<T extends Result>
{
	private static final String TAG = "HttpBuilder";
	
	private Class<T> mClass;
	private Callback<T> httpCallback;
	
	public Builder(Callback<T> callback)
	{
		httpCallback = callback;
	}
	
	public void setClass(Class<T> cls)
	{
		mClass = cls;
	}
	
	public void get(Url url)
	{
		if(mClass == null)
		{
			HttpLog.logE(TAG, "mClass is null.");
			return;
		}
		
		if(httpCallback == null)
		{
			HttpLog.logE(TAG, "httpCallback is null.");
			return;
		}
		
		Executer<T> execute = new Executer<T>(mClass, httpCallback);
		execute.get(url);
	}
	
	public void post(Url url)
	{
		if(mClass == null)
		{
			HttpLog.logE(TAG, "mClass is null.");
			return;
		}
		
		if(httpCallback == null)
		{
			HttpLog.logE(TAG, "httpCallback is null.");
			return;
		}
		
		Executer<T> execute = new Executer<T>(mClass, httpCallback);
		execute.post(url);
	}
}