package com.focustech.baseandroid.net;

import android.annotation.SuppressLint;

import com.focustech.baseandroid.net.configuration.Code;
import com.focustech.baseandroid.net.params.Url;
import com.focustech.baseandroid.util.BaseStringUtils;
import com.loopj.android.http.RequestParams;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

public abstract class Request extends Url implements Serializable
{
	private static final long serialVersionUID = 1L;

	@Override
	public final RequestParams getParams()
	{
		Params params = new Params();
		buildRequestParams(params);
		encodeRequestParams(params);
		return params;
	}
	
	/**
	 * 构造请求参数
	 * 
	 * @param params
	 */
	protected abstract void buildRequestParams(Params params);

	/**
	 * 在请求参数中添加编码信息
	 * 
	 * @param params
	 */
	@SuppressLint("SimpleDateFormat")
	protected void encodeRequestParams(Params params)
	{
		//添加版本号
		String v = Code.v;
		params.put("v", v);
		//添加用户ID
		String uid = Code.uid;
		params.put("uid", uid);
		//添加渠道ID
		String sid = Code.sid;
		params.put("sid", sid);
		//添加时间戳
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String ts = sdf.format(new Date());
		params.put("ts", ts);
		//添加加密信息
		StringBuilder sig = new StringBuilder();
		sig.append(uid).append(",");
		sig.append(sid).append(",");
		sig.append(ts).append(",");

		if(params.has("loginId"))
		{
			sig.append(params.getStringVlaue("loginId")).append(",");
		}
		if(params.has("orderId"))
		{
			sig.append(params.getStringVlaue("orderId")).append(",");
		}
		if(params.has("policyId"))
		{
			sig.append(params.getStringVlaue("policyId")).append(",");
		}
		if(params.has("applicationId"))
		{
			sig.append(params.getStringVlaue("applicationId")).append(",");
		}
		sig.append(BaseStringUtils.md5(Code.appsecret));
		params.put("sig", BaseStringUtils.md5(sig.toString()));
	}
}