package com.focustech.baseandroid.net;


import android.os.Handler;


import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;

import com.focustech.baseandroid.net.params.Result;
import com.focustech.baseandroid.net.params.Url;

public abstract class WHttp<T extends Result> implements Callback<T>
{
	private Builder<T> httpBuilder;
	private HashMap<String, Object> dataMap;

	/**网络访问成功*/
	public static final int SUCESS=0;
	/**网络访问失败*/
	public static final int FAILURE=-1;
	
	public WHttp()
	{
		httpBuilder = new Builder<T>(this);
		dataMap = new HashMap<String, Object>(3);
	}
	
	public final void put(String key, Object value)
	{
		dataMap.put(key, value);
	}
	
	protected final String getString(String key)
	{
		Object obj = dataMap.get(key);
		return String.valueOf(obj);
	}
	
	public final void get(Url url)
	{
		httpBuilder.setClass(getType());
		httpBuilder.get(url);
	}
	
	public final void post(Url url)
	{
		httpBuilder.setClass(getType());
		httpBuilder.post(url);
	}


	/**
	 * 获得指定文件的byte数组
	 */
	private static  byte[] getBytes(String filePath){
		byte[] buffer = null;
		try {
			File file = new File(filePath);
			FileInputStream fis = new FileInputStream(file);
			ByteArrayOutputStream bos = new ByteArrayOutputStream(1000);
			byte[] b = new byte[1000];
			int n;
			while ((n = fis.read(b)) != -1) {
				bos.write(b, 0, n);
			}
			fis.close();
			bos.close();
			buffer = bos.toByteArray();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return buffer;
	}
	
	public abstract Class<T> getType();

	@Override
	public void onError()
	{
		//在匿名内部类中执行
	}

	@Override
	public void onFailure(T resp)
	{
		//在匿名内部类中执行
	}

	@Override
	public void onSuccess(T resp)
	{
		//在匿名内部类中执行
	}
	
	@Override
	public void onComplete()
	{
		//在匿名内部类中执行
	}
}