package com.focustech.baseandroid.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import android.content.Context;

import com.focustech.baseandroid.BaseApp;
import com.focustech.baseandroid.BuildConfig;

/**
 * 操作Properties的工具类
 * 
 * @author zhangzheng
 */

public class BasePropertiesUtil {

	public static final String NET_TEST = "netTest.properties";

	public static String getValue(String name, String key) {
		
		Context context=BaseApp.getAPP();

		if (name.equals(NET_TEST)) {
			key = key + "-" + "true";
		}

		InputStream in = null;
		try {
			in = context.getAssets().open(name);
			Properties proper = new Properties();
			proper.load(in);

			return proper.getProperty(key, "");
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (in != null) {
					in.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return "";
	}

	@SuppressWarnings("unused")
	public static boolean hasKey(String name, String key) {

		if (BuildConfig.DEBUG == false)
			return false;
		
		String value = getValue(name, key);
		if (value.equals(""))
			return false;

		return true;
	}

}
