package com.focustech.baseandroid.util;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

/**
 * 反射获得Get和Set方法
 * 
 * @author zhangzheng
 * 
 */
public class PropertyDescriptor {

	/**
	 * 
	 * java反射bean的get方法
	 * 
	 * 
	 * 
	 * @param objectClass
	 * 
	 * @param fieldName
	 * 
	 * @return
	 */

	@SuppressWarnings("unchecked")
	public static Method getGetMethod(Class objectClass, String fieldName) {

		StringBuffer sb = new StringBuffer();

		sb.append("get");

		sb.append(fieldName.substring(0, 1).toUpperCase());

		sb.append(fieldName.substring(1));

		try {

			return objectClass.getMethod(sb.toString());

		} catch (Exception e) {

		}

		return null;

	}

	/**
	 * 
	 * java反射bean的set方法
	 * 
	 * 
	 * 
	 * @param objectClass
	 * 
	 * @param fieldName
	 * 
	 * @return
	 */

	@SuppressWarnings("unchecked")
	public static Method getSetMethod(Class objectClass, String fieldName) {

		try {

			Class[] parameterTypes = new Class[1];

			Field field = objectClass.getDeclaredField(fieldName);

			parameterTypes[0] = field.getType();

			StringBuffer sb = new StringBuffer();

			sb.append("set");

			sb.append(fieldName.substring(0, 1).toUpperCase());

			sb.append(fieldName.substring(1));

			Method method = objectClass
					.getMethod(sb.toString(), parameterTypes);

			return method;

		} catch (Exception e) {

			e.printStackTrace();

		}

		return null;

	}

	/**
	 * 
	 * 执行set方法
	 * 
	 * 
	 * 
	 * @param o执行对象
	 * 
	 * @param fieldName属性
	 * 
	 * @param value值
	 */

	public static void invokeSet(Object o, String fieldName, Object value) {

		Method method = getSetMethod(o.getClass(), fieldName);

		try {
			Class<?> cla = method.getParameterTypes()[0];
			if (value.getClass() == String.class) {
				if (cla == int.class || cla == Integer.class) {
					value = Integer.valueOf((String) value);
				} else if (cla == double.class || cla == Double.class) {
					value = Double.valueOf((String) value);
				} else if (cla == float.class || cla == Float.class) {
					value = Float.valueOf((String) value);
				}
			}
			method.invoke(o, value);

		} catch (Exception e) {

			e.printStackTrace();

		}

	}

	/**
	 * 
	 * 执行get方法
	 * 
	 * 
	 * 
	 * @param o执行对象
	 * 
	 * @param fieldName属性
	 */

	public static Object invokeGet(Object o, String fieldName) {

		Method method = getGetMethod(o.getClass(), fieldName);

		try {

			return method.invoke(o, new Object[0]);

		} catch (Exception e) {

			e.printStackTrace();

		}

		return null;

	}

}
