package com.focustech.baseandroid.view;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.GridView;

/**
 * 不对Item进行复用，初始化出GridView全部视图，用于解决GridView和ScrollView获得GridView
 *之前的冲突，但是会对内存有较高的占用，滑动性能会更好（仅仅建议用于解决滑动冲突的时候使用）
 * Created by zhangzheng on 2015/10/27.
 */
public class SGridView extends GridView {

    public SGridView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec)
    {
        int expandSpec = MeasureSpec.makeMeasureSpec(Integer.MAX_VALUE >> 2, MeasureSpec.AT_MOST);
        super.onMeasure(widthMeasureSpec, expandSpec);
    }
}
