package com.focustech.baseandroid.view;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.ListView;

/**
 *不对Item进行复用，初始化出ListView全部视图，用于解决ListView和ScrollView获得ListView
 *之前的冲突，但是会对内存有较高的占用，滑动性能会更好（仅仅建议用于解决滑动冲突的时候使用）
 * @author zhangzheng
 *
 */
public class SListView extends ListView
{
	public SListView(Context context, AttributeSet attrs)
	{
		super(context, attrs);
	}

	public SListView(Context context)
	{
		super(context);
	}

	protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec)
	{
		int expandSpec = MeasureSpec.makeMeasureSpec(Integer.MAX_VALUE >> 2, MeasureSpec.AT_MOST);
		super.onMeasure(widthMeasureSpec, expandSpec);
	}
}