package com.nuance.dragon.toolkit;

/**
 * Information about the Nuance Mobile Toolkit build
 */
public final class Build
{
/*
    This section needs to be updated manually upon engine integration
    so the automated build system can populate the update notes correctly.

[START_COMPONENT_SECTION]
- Components (engine, audio, protocol stack versions):
    NMSP: 6.0-B020/5.2.3-B009
    SPEEX: 1.2-beta
    OPUS: 1.1
    ELVIS: 30.0042.vs5.v.06
    VOCON: 4.7
    NVSL: 4.7.0
    SSE : 3.16.0
    VOCALIZER FOR AUTO: 5.6.1
    VOCALIZER EXPRESSIVE: 1.4.1
    EDR: 1.1.0B3

- Lingware (ASR, TTS data packs):
    ELVIS: \\mt-nas02\nvc-sdk\nmsp-builds\NuanceMobileToolkit-lingware\ELVIS.30.0042.vs5
    NVSL: \\mt-nas02\nvc-sdk\nmsp-builds\NuanceMobileToolkit-lingware\NVSL4.7.0
    VOCALIZER EXPRESSIVE: https://network.nuance.com/portal/server.pt
    VOCALIZER FOR AUTO: https://network.nuance.com/portal/server.pt
 [END_COMPONENT_SECTION]
 */

    /** The version string */
    public static final String VERSION = "1.8.0-B018"; // Automatically populated, do not modify!

    /** The current development code name (the string "REL" if this is a release build) */
    public static final String CODENAME = "REL"; // Automatically populated, do not modify!

    /** Internal build indication */
    public static final boolean DEBUG = debug(); // For internal purposes

    /** The client component version strings */
    public class COMPONENT
    {
        /** NMSP SDK version */
        public static final String NMSP = "6.0-B020/5.2.3-B009";

        /** SPEEX library version */
        public static final String SPEEX = "1.2-beta";

        /** OPUS library version */
        public static final String OPUS = "1.1";

        /** ELVIS fork */
        public static final String ELVIS = "30.0042.vs5.v.06";

        /** VOCON Hybrid version */
        public static final String VOCON = "4.7";

        /** Nuance Voice Security Library version */
        public static final String NVSL = "4.7.0";

        /** SSE library version */
        public static final String SSE = "3.16.0";

        /** @deprecated Vocalizer for Automotive version */
        @Deprecated
        public static final String VFA = "5.6.1";

        /** Vocalizer Expressive version */
        public static final String VEX = "1.4.1";

        /** Embedded dictation recognizer */
        public static final String EDR = " 1.1.0B3";
    }

    private static boolean debug()
    {
        boolean debug = false;
        java.lang.reflect.Method methods[] = Build.class.getDeclaredMethods();
        for (java.lang.reflect.Method m : methods) {
            if (m.getName().endsWith("debug")) {
                debug = true;
                break;
            }
        }
        return debug;
    }
}
