package com.nuance.dragon.toolkit.audio;

public interface AudioEnergyListener
{
    /**
     * Called when a new energy value is available
     * @param energyLevel The audio energy level is within the range from 0 to 90, the value is proportional to
     * the loudness of the audio. Based on the experiments, only the audio with the
     * energy value greater than 40 will be heard by normal human ears.
     * @param speech Only true when the system confidently thinks there is speech in this audio chunk.
     */
    void onEnergyLevelAvailable(float energyLevel, boolean speech);
}
