package com.nuance.dragon.toolkit.audio;

/**
 * A TTS marker to highlight text currently being generated and played.
 */
public class TtsMarker
{
    /** The TTS text */
    public final String text;
    /** The TTS fragment start */
    public final int start;
    /** The TTS fragment length */
    public final int len;

    public TtsMarker(String text, int start, int len)
    {
        this.text = text;
        this.start = start;
        this.len = len;
    }

    @Override
    public String toString() {
        return "TtsMarker [text=" + text + ", start=" + start + ", len=" + len
                + "]";
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + len;
        result = prime * result + start;
        result = prime * result + ((text == null) ? 0 : text.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        TtsMarker other = (TtsMarker) obj;
        if (len != other.len)
            return false;
        if (start != other.start)
            return false;
        if (text == null) {
            if (other.text != null)
                return false;
        } else if (!text.equals(other.text))
            return false;
        return true;
    }
}
