/*------------------------------------------------------------------------

  Copyright 2012-2012 Nuance Communications, Inc.

------------------------------------------------------------------------*/
package com.nuance.dragon.toolkit.audio.bluetooth;


public interface BluetoothListener {
    /**
     * Called when the BT audio is connected and ready to use. In more detail,
     * when both headset and Bluetooth SCO are connected.
     * @param status - the resulting status
     * See {@link BluetoothManager.Status} for available status codes.
     */
    public void onAudioConnected(int status);

    /**
     * Called when the BT audio is disconnected, for any reason, and can no longer be used.
     * Communicating the exact reason is out of scope of this API.
     * @param status - the resulting status
     * See {@link BluetoothManager.Status} for available status codes.
     */
    public void onAudioDisconnected(int status);

    /**
     * Called when the BT device is connected.
     * @param status - the resulting status
     * See {@link BluetoothManager.Status} for available status codes.
     */
    public void onDeviceConnected(int status);

    /**
     * Called when the BT device is disconnected.
     * Communicating the exact reason is out of scope of this API.
     * @param status - the resulting status
     * See {@link BluetoothManager.Status} for available status codes.
     */
    public void onDeviceDisconnected(int status);

    public void onBluetoothInitialized(int status);

    public void onBluetoothReleased(int status);
}
