/*------------------------------------------------------------------------

  Copyright 2006-2012 Nuance Communications, Inc.

------------------------------------------------------------------------*/
package com.nuance.dragon.toolkit.audio.bluetooth.impl;


import android.media.AudioManager;
import android.media.MediaRecorder.AudioSource;

public class Audio {

    public static final int DEFAULT_AUDIO_SOURCE;
    public static final int DEFAULT_AUDIO_STREAM;
    public static final int BLUETOOTH_STREAM;
    public static final int MUSIC_STREAM;
    public static final int VOICE_CALL_STREAM;

    static {
        Reflection r = new Reflection();
        Integer audioSource = (Integer) r.getFieldValue(AudioSource.class, "VOICE_RECOGNITION");
        if(audioSource == null) {
            audioSource = AudioSource.DEFAULT;
        }
        DEFAULT_AUDIO_SOURCE = audioSource;

        if (AndroidVersion.USE_MUSIC_STREAM_FOR_BLUETOOTH) {
            DEFAULT_AUDIO_STREAM = AudioManager.STREAM_MUSIC;
        } else {
            DEFAULT_AUDIO_STREAM = AudioManager.STREAM_RING;
        }
        BLUETOOTH_STREAM = (Integer) r.getFieldValue(AudioManager.class, "STREAM_BLUETOOTH_SCO");
        MUSIC_STREAM = AudioManager.STREAM_MUSIC;
        VOICE_CALL_STREAM = AudioManager.STREAM_VOICE_CALL;
    }
}
