/*------------------------------------------------------------------------

  Copyright 2006-2011 Nuance Communications, Inc.

------------------------------------------------------------------------*/
package com.nuance.dragon.toolkit.audio.bluetooth.impl;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

import android.util.Log;

public class BtListenerInvocationHandler implements InvocationHandler {

    public static final String TAG = "BtListenerInvocationHandler";
    public static final boolean DEBUG = Bluetooth.DEBUG;

    protected BtServiceListener mBtServiceListener;

    public BtListenerInvocationHandler(BtServiceListener listener) {
        mBtServiceListener = listener;
    }

    public Object invoke(Object proxy, Method method, Object[] args) {
        if(DEBUG) Log.d(TAG, "BtListenerInvocationHandler.invoke() mBtServiceListener = " + mBtServiceListener
                        + " method = " + method);
        if(method != null && mBtServiceListener != null) {
            if(method.getName().equals("onServiceConnected")) {
                mBtServiceListener.onServiceConnected(new BtServiceListenerParams(args));
            } else if (method.getName().equals("onServiceDisconnected")){
                mBtServiceListener.onServiceDisconnected(new BtServiceListenerParams(args));
            } else {
                try {
                    method.invoke(mBtServiceListener, args);
                } catch(IllegalAccessException iae) {
                    Log.e(TAG, "ListenerInvocationHandler.invoke() IllegalAccessException calling " + method, iae);
                } catch(java.lang.reflect.InvocationTargetException ite) {
                    Log.e(TAG, "ListenerInvocationHandler.invoke() InvocationTargetException calling " + method, ite);
                }
            }
        }
        return null;
    }
}
