package com.nuance.dragon.toolkit.cloudservices;

import org.json.JSONObject;

class ASError {
    public final static short INTERNAL_ERROR_CODE_NOT_AVAILABLE                = 0;
    public final static short INTERNAL_ERROR_CODE_SERVER_ERROR                 = 1;
    public final static short INTERNAL_ERROR_THIRD_PARTY_LOGIN_MISSING         = 2;
    public final static short INTERNAL_ERROR_CODE_REGISTRATION_CACHING_FAILURE = 3;
    public final static short INTERNAL_ERROR_CODE_CONNECTION_FAILURE           = 4;
    public final static short INTERNAL_ERROR_CODE_CONNECTION_FAILURE_SECURITY  = 5;

    public final short InternalErrorCode;
    public final int HttpResponseCode;
    public final String HttpResponseBody;
    public final JSONObject Json;

    ASError(short internalErrorCode)
    {
        this(internalErrorCode, 0, null);
    }

    ASError(int httpResponseCode, String httpResponseBody)
    {
        this(INTERNAL_ERROR_CODE_NOT_AVAILABLE, httpResponseCode, httpResponseBody);
    }

    ASError(short internalErrorCode, int httpResponseCode, String httpResponseBody)
    {
        InternalErrorCode = internalErrorCode;
        HttpResponseCode = httpResponseCode;
        HttpResponseBody = httpResponseBody;
        JSONObject json = null;
        try {
            json = new JSONObject(httpResponseBody);
        } catch (Exception e) {}
        Json = json;
    }

    @Override
    public String toString()
    {
        return "[internal error code: " + InternalErrorCode + "]" +
               " [response code: " + HttpResponseCode + "]" +
               " [response msg: " + HttpResponseBody + "]";
    }

}
