package com.nuance.dragon.toolkit.cloudservices;

import com.nuance.dragon.toolkit.oem.api.internal.Checker;

/**
 * A byte-array parameter to be sent via {@link Transaction#addParam}.
 */
public class BytesParam extends Param
{
    private final byte[] _data;

    /**
     * @param key  The name of this Bytes parameter (cannot be NULL or Empty)
     * @param data The associated binary data, the data will be deep copied. (cannot by NULL)
     */
    public BytesParam(String key, byte[] data)
    {
        super(TYPE_BYTES, key);
        Checker.checkArgForNull("data", data);
        _data = data;
    }

    @Override
    void send(CommandContext commandContext) throws Exception
    {
        commandContext.sendDataParam(key, _data);
    }
}
