package com.nuance.dragon.toolkit.cloudservices;

import java.util.Map;

import com.nuance.dragon.toolkit.core.calllog.SessionEvent;
import com.nuance.dragon.toolkit.core.calllog.SessionEventBuilder;
import com.nuance.dragon.toolkit.oem.api.internal.Checker;

public class CalllogSessionEventImpl implements SessionEvent {

    private final boolean _newCop;
    private final com.nuance.nmsp.client.sdk.components.core.calllog.SessionEvent  _sessionEvent1;
    private final com.nuance.nmsp.client2.sdk.components.core.calllog.SessionEvent _sessionEvent2;

    public CalllogSessionEventImpl(Object sessionEvent, boolean newCop)
    {
        _newCop = newCop;
        if (!_newCop)
        {
            _sessionEvent1 = (com.nuance.nmsp.client.sdk.components.core.calllog.SessionEvent)sessionEvent;
            _sessionEvent2 = null;
        }
        else
        {
            _sessionEvent2 = (com.nuance.nmsp.client2.sdk.components.core.calllog.SessionEvent)sessionEvent;
            _sessionEvent1 = null;
        }
    }

    protected Object getSessionEvent()
    {
        return !_newCop ? _sessionEvent1 : _sessionEvent2;
    }

    @Override
    public SessionEventBuilder createChildEventBuilder(String eventName) {

        Checker.checkArgForNull("eventName", eventName);

        if ((!_newCop ? _sessionEvent1 : _sessionEvent2) != null) {
            return new CalllogSessionEventBuilderImpl(!_newCop ? _sessionEvent1.createChildEventBuilder(eventName) : _sessionEvent2.createChildEventBuilder(eventName), _newCop);
        }
        return null;
    }

    @Override
    public SessionEventBuilder createChildEventBuilder(String eventName, String schemaVersion)
    {
        Checker.checkArgForNull("eventName", eventName);

        if ((!_newCop ? _sessionEvent1 : _sessionEvent2) != null) {
            return new CalllogSessionEventBuilderImpl(!_newCop ? _sessionEvent1.createChildEventBuilder(eventName, schemaVersion) : _sessionEvent2.createChildEventBuilder(eventName, schemaVersion), _newCop);
        }
        return null;
    }

    @Override
    public String getId() {
        return !_newCop ? _sessionEvent1.getId() : _sessionEvent2.getId();
    }

    @Override
    public String getName()
    {
        return !_newCop ? _sessionEvent1.getName() : _sessionEvent2.getName();
    }

    @SuppressWarnings("unchecked")
    @Override
    public Map<String, String> getRefIds()
    {
        return !_newCop ? _sessionEvent1.getRefIds() : _sessionEvent2.getRefIds();
    }

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (!(obj instanceof CalllogSessionEventImpl))
            return false;
        CalllogSessionEventImpl other = (CalllogSessionEventImpl) obj;
        if ((!_newCop ? _sessionEvent1 : _sessionEvent2) == null)
        {
            if ((!other._newCop ? other._sessionEvent1 : other._sessionEvent2) != null)
                return false;
        }
        else if (!(!_newCop ? _sessionEvent1.equals(other._sessionEvent1) : _sessionEvent2.equals(other._sessionEvent2)))
            return false;

        return true;
    }
}
