package com.nuance.dragon.toolkit.cloudservices;

/**
 * A parameter to hold the name and value of a possible choice according to the
 * results returned by the command on the Nuance Mobile Application Server host.
 */
public class ChoiceParam extends StringParam
{
    /**
     * @param key   name of this Choice parameter expected by the command (cannot be NULL or Empty)
     * @param value a value that represents the choice specified by the client (cannot be NULL)
     */
    public ChoiceParam(String key, String value)
    {
        super(key, value);
    }

    @Override
    void send(CommandContext commandContext) throws Exception
    {
        commandContext.sendChoiceParam(key, _value);
    }
}
