package com.nuance.dragon.toolkit.cloudservices;

import java.util.Enumeration;
import java.util.Hashtable;

import com.nuance.nmsp.client2.sdk.common.defines.NMSPDefines;

/**
 * Represents a configuration for {@link CloudConfig}. It allows CloudServices to receive MDS messages or not.
 */
public class MdsMessageConfig implements NMTConfig
{
    private Hashtable<String, Object> _parameters = new Hashtable<String, Object>();

    /**
     * Make a MdsMessageConfig object.
     *
     * @param enableMdsMessage Enable or Disable MDS messages
     */
    public MdsMessageConfig(boolean enableMdsMessage)
    {
        if (enableMdsMessage) {
            _parameters.put(NMSPDefines.NMSP_DEFINES_ALLOW_MDS_MESSAGES, "TRUE".getBytes());
        }
        else {
        	_parameters.put(NMSPDefines.NMSP_DEFINES_ALLOW_MDS_MESSAGES, "FALSE".getBytes());
        }
    }


    @Override
    public int size() {
        return _parameters.size();
    }

    @Override
    public Enumeration<String> keys() {
        return _parameters.keys();
    }

    @Override
    public Object getValue(String key) {
        return _parameters.get(key);
    }
}
