package com.nuance.dragon.toolkit.cloudservices;

import com.nuance.dragon.toolkit.core.data.Data;


/**
 * A Sequence Chunk Parameter. Sequence Chunk is used to send
 * large amounts of data in dictionary format (like a contact list in
 * smaller pieces (chunks).
 */
public class SeqChunkParam extends DictionaryParam
{
    /**
     * @param key  The name of the Sequence Chunk Parameter specified by the
     *             Command on Nuance Mobile Application Server.
     * @param dict Dictionary that contains all the dictionary contents
     */
    public SeqChunkParam(String key, Data.Dictionary dict)
    {
        super(TYPE_SEQUENCE_CHUNK, key, dict);
    }

    @Override
    void send(CommandContext commandContext) throws Exception
    {
        commandContext.sendSeqChunkParam(key, _dict);
    }
}
