package com.nuance.dragon.toolkit.cloudservices;

import com.nuance.dragon.toolkit.core.data.Data;


/**
 * Sequence End Parameter, which indicates the end of a series
 * of data chunks that were sent.
 */
public class SeqEndParam extends DictionaryParam
{
    /**
     * @param key  The name of the Sequence End Parameter specified by the
     *             Command on Nuance Mobile Application Server.
     * @param dict Dictionary containing all the dictionary contents
     */
    public SeqEndParam(String key, Data.Dictionary dict)
    {
        super(TYPE_SEQUENCE_END, key, dict);
    }

    @Override
    void send(CommandContext commandContext) throws Exception
    {
        commandContext.sendSeqEndParam(key, _dict);
    }
}
