package com.nuance.dragon.toolkit.cloudservices;

import com.nuance.dragon.toolkit.core.data.Data;


/**
 * PDX Sequence Start Parameter, which indicates the start of a series
 * of data chunks that are going to be sent.
 */
public class SeqStartParam extends DictionaryParam
{
    /**
     *
     * @param key  name of the Sequence Start Parameter specified by the
     *             Command on Nuance Mobile Application Server.
     * @param dict a Data.Dictionary containing all the dictionary contents
     */
    public SeqStartParam(String key, Data.Dictionary dict)
    {
        super(TYPE_SEQUENCE_START, key, dict);
    }

    @Override
    void send(CommandContext commandContext) throws Exception
    {
        commandContext.sendSeqStartParam(key, _dict);
    }
}
