package com.nuance.dragon.toolkit.cloudservices;

import com.nuance.dragon.toolkit.core.data.Data;
import com.nuance.dragon.toolkit.oem.api.Logger;

/**
 * A sequence parameter to be sent via {@link Transaction#addParam}.
 * <p>
 * A 'sequence' is a sequence of PDX data entries that can be streamed to the
 * server as they are added to the transaction. Each 'chunk' will be streamed
 * out under the same param.
 * <p>
 */
public class SequenceParam extends Param
{
    // TODO: Revisit this, with SeqStart and SeqEnd
    //private final PdxData.Sequence _seq;

    /**
     * @param key The name of the Sequence Parameter
     * @param seq The actual sequence data object
     */
    public SequenceParam(String key, Data.Sequence seq)
    {
        super(TYPE_SEQUENCE, key);
        //_seq = seq;
    }

    @Override
    void send(CommandContext commandContext) throws Exception
    {
        Logger.warn(this, "Sending single sequence param is not supported, sequence param should be wrapped by DictionaryParam");
    }
}
