package com.nuance.dragon.toolkit.cloudservices;


/**
 * This state sends the transaction to the server. It initializes the command,
 * sends parameters, and waits for the transaction to be finished and/or for all
 * parameters to finish sending before transitioning to the
 * {@link TransactionStateFinished}.
 */
class TransactionStateAuthenticating extends TransactionState
{
    TransactionStateAuthenticating(CommandContext commandContext, Transaction transaction)
    {
        super(commandContext, true, false, transaction);
    }

    @Override
    void enter()
    {
        super.enter();
        _context.getSession();
    }

    @Override
    void getSessionSucceeded(ASSession session)
    {
        switchToState(new TransactionStateSending(_context, _transaction));
    }
}
