package com.nuance.dragon.toolkit.cloudservices;

import com.nuance.dragon.toolkit.cloudservices.Transaction.InternalListener;
import com.nuance.dragon.toolkit.oem.api.Logger;

/**
 * Terminal state for transactions. TODO update this class to properly report
 * results and errors (or possibly split it into separate states for results and
 * errors).
 */
class TransactionStateFinished extends TransactionState
{
    TransactionStateFinished(CommandContext context, Transaction transaction)
    {
        super(context, false, true, transaction);
    }

    @Override
    void enter()
    {
        super.enter();
        if (_context != null)
        {
            _context.freeResource();
        }
        InternalListener completeListener = _transaction.getInternalListener();
        if (completeListener != null)
            completeListener.onFinished(_transaction);
    }

    @Override
    void cancel()
    {
        // Override cancel() method to do nothing
        Logger.warn(this, "cancel() method called in finished state");
    }
}
