package com.nuance.dragon.toolkit.cloudservices;

/**
 * Starting state for transactions. When {@link #start} is called, this will
 * switch to the {@link TransactionStateSending} state.
 */
class TransactionStateIdle extends TransactionState
{
    TransactionStateIdle(Transaction transaction)
    {
        super(null, false, false, transaction);
    }

    @Override
    void start(CommandContext commandContext)
    {
        switchToState(!commandContext.newCop() ? new TransactionStateSending(commandContext, _transaction) : new TransactionStateAuthenticating(commandContext, _transaction));
    }
}
