package com.nuance.dragon.toolkit.edr;

import com.nuance.dragon.toolkit.edr.internal.UserVocabularyImpl;

/**
 * Represents a collection of IWordSet objects.
 */
public abstract class UserVocabulary {

    /**
     * Adds a WordSet to the current list.
     * @param wordset word set to be added.
     * @see WordSet
     */
    public abstract void addWordSet(WordSet wordset);

    /**
     * Removes all WordSet from the list.
     */
    public abstract void clearWordSets();

    /**
     * Returns an UserVocabulary compatible object.
     * @return an UserVocabulary compatible object.
     */
    static public UserVocabulary createUserVocabulary() {
        return new UserVocabularyImpl();
    }
}
