package com.nuance.dragon.toolkit.edr.internal;

import com.nuance.dragon.toolkit.edr.EdrError;
import com.nuance.dragon.toolkit.edr.internal.jni.EDRReturnCode;
import com.nuance.dragon.toolkit.edr.internal.jni.edr;

public class EdrErrorImpl extends EdrError {

    private final EDRReturnCode _edrCode;
    private final int _reasonCode;

    public EdrErrorImpl(EDRReturnCode code) {
        _edrCode = code;
        _reasonCode = code.enumToInt();
    }

    @Override
    public int getReasonCode() {
        return _reasonCode;
    }

    @Override
    public String getReason() {
        if(EdrRecognizerImpl.LOAD_NATIVE_LIBRARY_SUCCESS) {
            StringBuffer reason = new StringBuffer();
            edr.JNIEDRReturnCodeToString(_edrCode, reason);

            return reason.toString();
        }
        else
            return "unknown";
    }

}
