package com.nuance.dragon.toolkit.edr.internal;

import com.nuance.dragon.toolkit.edr.internal.jni.EDRLogLevel;
import com.nuance.dragon.toolkit.edr.internal.jni.ILogListener;
import com.nuance.dragon.toolkit.edr.internal.jni.edr;
import com.nuance.dragon.toolkit.oem.api.Logger;

public class EdrLogger implements ILogListener {

    public void registerCallback() {
        edr.EDRRegisterLogCallback(this);
    }

    public void unregisterCallback() {
        edr.EDRRegisterLogCallback(null);
    }

    @Override
    public void log(String id, int level, String msg) {
        EDRLogLevel edrLevel = EDRLogLevel.intToEnum(level);

        if(id.equals("S2"))
            id = null;

        switch(edrLevel) {
        case EDRLOGLEVEL_DEBUG:
            Logger.debug(id, msg);
            break;
        case EDRLOGLEVEL_ERROR:
            Logger.error(id, msg);
            break;
        case EDRLOGLEVEL_FATAL:
            Logger.error(id, msg);
            break;
        case EDRLOGLEVEL_INFO:
            Logger.info(id, msg);
            break;
        case EDRLOGLEVEL_TRACE:
            Logger.verbose(id, msg);
            break;
        case EDRLOGLEVEL_WARNING:
            Logger.warn(id, msg);
            break;
        default:
            break;
        }
    }
}
