package com.nuance.dragon.toolkit.edr.internal;

import java.util.ArrayList;

import com.nuance.dragon.toolkit.edr.EdrResult;
import com.nuance.dragon.toolkit.edr.internal.jni.MutableInteger;
import com.nuance.dragon.toolkit.edr.internal.jni.StringArray;

public class EdrResultImpl extends EdrResult {

    private ArrayList<String> _results = new ArrayList<String>();
    private final boolean _isAtEndOfRecognition;

    public EdrResultImpl(StringArray results) {
        MutableInteger size = new MutableInteger();
        results.getSize(size);

        for(int i = 0; i < size.getValue(); ++i) {
            StringBuffer buffer = new StringBuffer();
            results.getStringAtIndex(i, buffer);
            _results.add(buffer.toString());
        }

        _isAtEndOfRecognition = false;
    }

    public EdrResultImpl(boolean isAtEndOfRecognition) {
        _isAtEndOfRecognition = isAtEndOfRecognition;
    }

    @Override
    public int getChoiceCount() {
        return _results.size();
    }

    @Override
    public String getChoiceAtIndex(int index) throws IndexOutOfBoundsException {
        return _results.get(index);
    }

    @Override
    public boolean isAtEndOfRecognition() {
        return _isAtEndOfRecognition;
    }

}
