package com.nuance.dragon.toolkit.edr.internal;

import com.nuance.dragon.toolkit.core.Word;
import com.nuance.dragon.toolkit.core.WordAction;
import com.nuance.dragon.toolkit.core.WordList;
import com.nuance.dragon.toolkit.core.WordList.WordIterator;
import com.nuance.dragon.toolkit.core.data.Data;
import com.nuance.dragon.toolkit.edr.internal.jni.WordSet;
import com.nuance.dragon.toolkit.grammar.content.StructuredContactManager;
import com.nuance.dragon.toolkit.oem.api.FileManager;

public class WordSetContactImpl extends WordSetBase {

    private final StructuredContactManager _contentManager;

    public WordSetContactImpl(String id, StructuredContactManager contentManager, FileManager fileManager) {
        super(id, fileManager);
        _contentManager = contentManager;
    }

    @Override
    public WordSet getEDRWordSet() {
        if(_contentManager == null)
            return null;

        com.nuance.dragon.toolkit.edr.internal.jni.WordSetContact wordSetContact = new com.nuance.dragon.toolkit.edr.internal.jni.WordSetContact();
        wordSetContact.init(getId(), 0);

        WordList wl = _contentManager.createWordList(getFileManager(), getId() + ".lst", true);
        if(wl == null)
            return wordSetContact;

        WordIterator it = wl.getFullIterator();
        while(it.hasNext()) {
            WordAction wa = it.next();
            Word word = wa.getWord();

            Data.Dictionary customForm = word.getCustomForm();

            String fn = "";
            String ln = "";
            String mn = "";

            if(customForm.getString("fn") != null)
                fn = customForm.getString("fn").toString();
            if(customForm.getString("ln") != null)
                ln = customForm.getString("ln").toString();
            if(customForm.getString("mn") != null)
                mn = customForm.getString("mn").toString();

            wordSetContact.addContact(fn + " " + ln + " " + mn, fn, ln, mn, "");
        }

        return wordSetContact;
    }
}
