package com.nuance.dragon.toolkit.edr.internal;

import com.nuance.dragon.toolkit.core.Word;
import com.nuance.dragon.toolkit.core.WordAction;
import com.nuance.dragon.toolkit.core.WordList;
import com.nuance.dragon.toolkit.core.WordList.WordIterator;
import com.nuance.dragon.toolkit.grammar.content.ContentManager;
import com.nuance.dragon.toolkit.oem.api.FileManager;

public class WordSetImpl extends WordSetBase {

    private final ContentManager _contentManager;

    public WordSetImpl(String id, ContentManager contentManager, FileManager fileManager) {
        super(id, fileManager);
        _contentManager = contentManager;
    }

    public ContentManager getContentManager() {
        return _contentManager;
    }

    public com.nuance.dragon.toolkit.edr.internal.jni.WordSet getEDRWordSet() {
        if(_contentManager == null)
            return null;

        com.nuance.dragon.toolkit.edr.internal.jni.WordSetDefault wordset = new com.nuance.dragon.toolkit.edr.internal.jni.WordSetDefault();
        wordset.init(getId(), 0);

        WordList wl = _contentManager.createWordList(getFileManager(), getId() + ".lst", false);
        if(wl == null)
            return wordset;

        WordIterator it = wl.getFullIterator();
        while(it.hasNext()) {
            WordAction wa = it.next();
            Word word = wa.getWord();

            String surfaceForm = word.getSurfaceForm();
            wordset.addItem(surfaceForm);
        }

        return wordset;
    }
}
