package com.nuance.dragon.toolkit.edr.internal.jni;

public enum EDRLogLevel {
  EDRLOGLEVEL_FATAL(1),
  EDRLOGLEVEL_ERROR(2),
  EDRLOGLEVEL_WARNING(3),
  EDRLOGLEVEL_INFO(4),
  EDRLOGLEVEL_DEBUG(5),
  EDRLOGLEVEL_TRACE(6);

  final private int javaValue;
  
  private static class NextValue {
    private static int _nextValue = 0;
  };
  
  private EDRLogLevel() {
    javaValue = NextValue._nextValue++;
  }
  
  private EDRLogLevel(int value) {
    javaValue = value;
	NextValue._nextValue = value + 1;
  }
  
  private int getIntValue() {
    return javaValue;
  }
  
  static public EDRLogLevel intToEnum(int value) {
    for(EDRLogLevel enumValue: EDRLogLevel.class.getEnumConstants()) {
      if(enumValue.getIntValue() == value)
	    return enumValue;
    }
	
	throw new IllegalArgumentException("Undefined enumeration value in " + EDRLogLevel.class + " for integer '" + value + "'.");
  }
  
  public int enumToInt() {
    return javaValue;
  }
}
