package com.nuance.dragon.toolkit.edr.internal.jni;

public enum EDRRecognizerEvent {
  EDRRECOGNIZEREVENT_RESULTS,
  EDRRECOGNIZEREVENT_END_OF_RECOGNITION,
  EDRRECOGNIZEREVENT_AUDIO_SAMPLE_INFORMATION;

  final private int javaValue;
  
  private static class NextValue {
    private static int _nextValue = 0;
  };
  
  private EDRRecognizerEvent() {
    javaValue = NextValue._nextValue++;
  }
  
  private EDRRecognizerEvent(int value) {
    javaValue = value;
	NextValue._nextValue = value + 1;
  }
  
  private int getIntValue() {
    return javaValue;
  }
  
  static public EDRRecognizerEvent intToEnum(int value) {
    for(EDRRecognizerEvent enumValue: EDRRecognizerEvent.class.getEnumConstants()) {
      if(enumValue.getIntValue() == value)
	    return enumValue;
    }
	
	throw new IllegalArgumentException("Undefined enumeration value in " + EDRRecognizerEvent.class + " for integer '" + value + "'.");
  }
  
  public int enumToInt() {
    return javaValue;
  }
}
