package com.nuance.dragon.toolkit.edr.internal.jni;

public enum EDRReturnCode {
  EDRRETURNCODE_SUCCESS(0),
  EDRRETURNCODE_FAILED,
  EDRRETURNCODE_NOT_INITIALIZED,
  EDRRETURNCODE_INVALID_PARAMETER,
  EDRRETURNCODE_INVALID_IN_CURRENT_STATE,
  EDRRETURNCODE_AUDIO_DATA_DISCARDED,
  EDRRETURNCODE_NOT_IN_VALID_RANGE,
  EDRRETURNCODE_UNSUPPORTED_LANGUAGE,
  EDRRETURNCODE_INVALID_LANGUAGE_SETTINGS,
  EDRRETURNCODE_INVALID_KEY,
  EDRRETURNCODE_INVALID_VALUE,
  EDRRETURNCODE_INVALID_SETTING,
  EDRRETURNCODE_WORDSET_ALREADY_REGISTERED,
  EDRRETURNCODE_WORDSET_NOT_REGISTERED,
  EDRRETURNCODE_WORSETS_ALREADY_BUILT,
  EDRRETURNCODE_COULD_NOT_OPEN_FILE,
  EDRRETURNCODE_COULD_NOT_OPEN_FILE_WRITE,
  EDRRETURNCODE_INVALID_FILE_FORMAT;

  final private int javaValue;
  
  private static class NextValue {
    private static int _nextValue = 0;
  };
  
  private EDRReturnCode() {
    javaValue = NextValue._nextValue++;
  }
  
  private EDRReturnCode(int value) {
    javaValue = value;
	NextValue._nextValue = value + 1;
  }
  
  private int getIntValue() {
    return javaValue;
  }
  
  static public EDRReturnCode intToEnum(int value) {
    for(EDRReturnCode enumValue: EDRReturnCode.class.getEnumConstants()) {
      if(enumValue.getIntValue() == value)
	    return enumValue;
    }
	
	throw new IllegalArgumentException("Undefined enumeration value in " + EDRReturnCode.class + " for integer '" + value + "'.");
  }
  
  public int enumToInt() {
    return javaValue;
  }
}
