package com.nuance.dragon.toolkit.edr.internal.jni;

public class Event {
  private long javaCPtr;
  protected boolean javaCMemOwn;

  protected Event(long cPtr, boolean cMemoryOwn) {
    javaCMemOwn = cMemoryOwn;
    javaCPtr = cPtr;
  }

  protected static long getCPtr(Event obj) {
    return (obj == null) ? 0 : obj.javaCPtr;
  }

  public synchronized void delete() {
    if (javaCPtr != 0) {
      if (javaCMemOwn) {
        javaCMemOwn = false;
        throw new UnsupportedOperationException("C++ destructor does not have public access");
      }
      javaCPtr = 0;
    }
  }

  public EDRReturnCode getType(EDRMutableRecognizerEvent type) { 
    return EDRReturnCode.intToEnum(edrJNI.Event_getType(javaCPtr, this, type)); 
  }

}
