package com.nuance.dragon.toolkit.edr.internal.jni;

public class EventResults extends Event {
  private long javaCPtr;

  protected EventResults(long cPtr, boolean cMemoryOwn) {
    super(edrJNI.EventResults_JNIUpcast(cPtr), cMemoryOwn);
    javaCPtr = cPtr;
  }

  protected static long getCPtr(EventResults obj) {
    return (obj == null) ? 0 : obj.javaCPtr;
  }

  public synchronized void delete() {
    if (javaCPtr != 0) {
      if (javaCMemOwn) {
        javaCMemOwn = false;
        throw new UnsupportedOperationException("C++ destructor does not have public access");
      }
      javaCPtr = 0;
    }
    super.delete();
  }

  public EDRReturnCode getResults(StringArray results) { 
    return EDRReturnCode.intToEnum(edrJNI.EventResults_getResults(javaCPtr, this, results)); 
  }

}
