package com.nuance.dragon.toolkit.edr.internal.jni;

public class StringArray {
  private long javaCPtr;
  protected boolean javaCMemOwn;

  protected StringArray(long cPtr, boolean cMemoryOwn) {
    javaCMemOwn = cMemoryOwn;
    javaCPtr = cPtr;
  }

  protected static long getCPtr(StringArray obj) {
    return (obj == null) ? 0 : obj.javaCPtr;
  }

  public synchronized void delete() 
  {
    if (javaCPtr != 0) {
      if (javaCMemOwn) {
        this.destroy();
        javaCMemOwn = false;
      }
      javaCPtr = 0;
    }
  }


  public StringArray() {
    javaCMemOwn = false;
    javaCPtr = 0;
    edr.createStringArray(this);
  }
  
  protected synchronized void setCPtr(long cPtr) {
    this.delete();
    if(cPtr != 0) {
      javaCPtr = cPtr;
      javaCMemOwn = true;
    }
  }
  
  protected synchronized void setCPtrNotOwn(long cPtr) {
    this.delete();
    if(cPtr != 0) {
      javaCPtr = cPtr;
      javaCMemOwn = false;
    }
  }
  
  protected void finalize() {
    this.delete();
  }

  private EDRReturnCode destroy() { 
    return EDRReturnCode.intToEnum(edrJNI.StringArray_destroy(javaCPtr, this)); 
  }

  public EDRReturnCode getSize(MutableInteger size) { 
    return EDRReturnCode.intToEnum(edrJNI.StringArray_getSize(javaCPtr, this, size)); 
  }

  public EDRReturnCode getStringAtIndex(int index, StringBuffer string) { 
    return EDRReturnCode.intToEnum(edrJNI.StringArray_getStringAtIndex(javaCPtr, this, index, string)); 
  }

  public EDRReturnCode push(String string) { 
    return EDRReturnCode.intToEnum(edrJNI.StringArray_push(javaCPtr, this, string)); 
  }

  public EDRReturnCode clear() { 
    return EDRReturnCode.intToEnum(edrJNI.StringArray_clear(javaCPtr, this)); 
  }

}
