package com.nuance.dragon.toolkit.edr.internal.jni;

public class StringMap {
  private long javaCPtr;
  protected boolean javaCMemOwn;

  protected StringMap(long cPtr, boolean cMemoryOwn) {
    javaCMemOwn = cMemoryOwn;
    javaCPtr = cPtr;
  }

  protected static long getCPtr(StringMap obj) {
    return (obj == null) ? 0 : obj.javaCPtr;
  }

  public synchronized void delete() 
  {
    if (javaCPtr != 0) {
      if (javaCMemOwn) {
        this.destroy();
        javaCMemOwn = false;
      }
      javaCPtr = 0;
    }
  }


  public StringMap() {
    javaCMemOwn = false;
    javaCPtr = 0;
    edr.createStringMap(this);
  }
  
  protected synchronized void setCPtr(long cPtr) {
    this.delete();
    if(cPtr != 0) {
      javaCPtr = cPtr;
      javaCMemOwn = true;
    }
  }
  
  protected synchronized void setCPtrNotOwn(long cPtr) {
    this.delete();
    if(cPtr != 0) {
      javaCPtr = cPtr;
      javaCMemOwn = false;
    }
  }
  
  protected void finalize() {
    this.delete();
  }

  private EDRReturnCode destroy() { 
    return EDRReturnCode.intToEnum(edrJNI.StringMap_destroy(javaCPtr, this)); 
  }

  public EDRReturnCode getValueForKey(String key, StringBuffer value) { 
    return EDRReturnCode.intToEnum(edrJNI.StringMap_getValueForKey(javaCPtr, this, key, value)); 
  }

  public EDRReturnCode setValueForKey(String key, String value) { 
    return EDRReturnCode.intToEnum(edrJNI.StringMap_setValueForKey(javaCPtr, this, key, value)); 
  }

  public EDRReturnCode removeKeyValue(String key) { 
    return EDRReturnCode.intToEnum(edrJNI.StringMap_removeKeyValue(javaCPtr, this, key)); 
  }

}
