package com.nuance.dragon.toolkit.edr.internal.jni;

public class WordSet {
  protected long javaCPtr;
  protected boolean javaCMemOwn;
  
  protected WordSet() {}
  
  public static long getCPtr(WordSet obj) {
    return (obj == null) ? 0 : obj.javaCPtr;
  }

  public synchronized void delete() 
  {
    if (javaCPtr != 0) {
      if (javaCMemOwn) {
        this.destroy();
        javaCMemOwn = false;
      }
      javaCPtr = 0;
    }
  }


  private EDRReturnCode destroy() { 
    return EDRReturnCode.intToEnum(edrJNI.WordSet_destroy(javaCPtr, this)); 
  }

  public EDRReturnCode init(String id, long options) { 
    return EDRReturnCode.intToEnum(edrJNI.WordSet_init(javaCPtr, this, id, options)); 
  }

  public EDRReturnCode getId(StringBuffer id) { 
    return EDRReturnCode.intToEnum(edrJNI.WordSet_getId(javaCPtr, this, id)); 
  }

  public EDRReturnCode getOptions(MutableInteger option) { 
    return EDRReturnCode.intToEnum(edrJNI.WordSet_getOptions(javaCPtr, this, option)); 
  }

  public EDRReturnCode clear() { 
    return EDRReturnCode.intToEnum(edrJNI.WordSet_clear(javaCPtr, this)); 
  }

}
