package com.nuance.dragon.toolkit.elvis;

import java.util.ArrayList;
import java.util.List;

import com.nuance.dragon.toolkit.elvis.ElvisNbestList.Entry.Word;

// TODO Comments needed
public class DefaultResultFilter implements ElvisResultFilter {

    public DefaultResultFilter()
    {
        // no state required.
    }

    @Override
    public ElvisResult applyFilter(ElvisResult input)
    {
        ElvisResult filteredResult = null;
        if (input.getChoiceCount() < 1) {
            return filteredResult;
        }

        ElvisNbestList inputnbest = input.getChoiceList();
        ArrayList<ElvisNbestList.Entry> filteredEntries = new ArrayList<ElvisNbestList.Entry>(inputnbest.size());

        ElvisNbestList.Entry sourceentry = inputnbest.get(0);
        ElvisNbestList.Entry filterentry = null;
        filteredEntries.add(sourceentry);

        for (int i = 1; i < inputnbest.size(); i++) {
            sourceentry = inputnbest.get(i);
            for (int j = 0; j < filteredEntries.size(); j++) {
                filterentry = filteredEntries.get(j);
                if (compareEntries(filterentry, sourceentry))
                {
                    sourceentry = null;
                    break;
                }
            }
            if (sourceentry != null) {
                filteredEntries.add(sourceentry);
            }
        }

        ElvisNbestList filterednbest = new ElvisNbestList(filteredEntries);
        if (filterednbest.size() > 0) {
            filteredResult = new ElvisResult(filterednbest, input.getGateConfidence(), input.getWakeupStartTimestamp(), input.getWakeupEndTimestamp(), input.getWakeupCommandStartTimestamp(), input.getWakeupCommandEndTimestamp(), input.getWakeupStatus(), input.getMiscLogging());
        }
        return filteredResult;
    }

    /* returns true if entries are semantically identical, false otherwise. */
    boolean compareEntries(ElvisNbestList.Entry left, ElvisNbestList.Entry right)
    {
        String lconstraint = left.getConstraint();
        String rconstraint = right.getConstraint();

        if (((lconstraint != null) && (rconstraint == null)) ||
            ((lconstraint == null) && (rconstraint != null)) ||
            ((lconstraint != null) && (rconstraint != null) && (!rconstraint.equals(lconstraint))))
        {
            /* If the constraints don't match, the results can't match. */
            return false;
        }

        List<Word> leftwords = left.getWords();
        List<Word> rightwords = right.getWords();
        int wordcount = leftwords.size();
        if (wordcount != rightwords.size()) {
            /* If the number of word slots don't match, these results don't match. */
            return false;
        }
        for (int i = 0; i < wordcount; i++) {
            if (!compareWords(leftwords.get(i), rightwords.get(i))) {
                return false;
            }
        }
        return true;
    }

    /* returns true if the words are semantically identical, or false if they are not. */
    boolean compareWords(Word left, Word right)
    {
        if (left.equals(right)) {
            return true;
        }
        return false;
    }

}
