package com.nuance.dragon.toolkit.elvis;

/**
 * Information about a supported Elvis model.
 */
public final class ElvisModelInfo
{
    /** The language */
    public final ElvisLanguage language;
    /** The quality */
    public final String quality;
    /** The frequency: 8000 or 16000 */
    public final int frequencyHz;

    ElvisModelInfo(ElvisLanguage language, String quality, int freqHz)
    {
        this.language = language;
        this.quality = quality;
        this.frequencyHz = freqHz;
    }

    @Override
    public String toString()
    {
        return language.toString() + ", " + quality + ", " + frequencyHz + "Hz";
    }
}
