package com.nuance.dragon.toolkit.elvis;

import java.util.regex.Matcher;

/** This file was automatically generated by 'create_elvis_config_classes.py'. */
class LangSpecs {
    private static final String BINFILE_FORMAT = "~type~_~language~_~quality~_~rate_khz~k.bin";
    static final String BINFILE_REGEX = "([a-z]+)_([a-z]+)_([a-z0-9]+)_(\\d+)k\\.bin";

    static String getBinfileName(String language, String quality, int samplingRateKhz)
    {
        return BINFILE_FORMAT.replace("~type~", "lvr").replace("~language~", language).replace("~quality~", quality).replace("~rate_khz~", String.valueOf(samplingRateKhz));
    }
    
    static String getMatchedBinfileLanguage(Matcher matcher)
    {
        return matcher.group(2);
    }

    static String getMatchedBinfileQuality(Matcher matcher)
    {
        return matcher.group(3);
    }
    
    static String getMatchedBinfileRateKhz(Matcher matcher)
    {
        return matcher.group(4);
    }
    

    /** Language code for "Cantonese Traditional" */ 
    public static final ElvisLanguage CANTONESE_TRADITIONAL = new ElvisLanguage("zhhk", "Cantonese Traditional");

    /** Language code for "European French" */ 
    public static final ElvisLanguage EUROPEAN_FRENCH = new ElvisLanguage("frfr", "European French");

    /** Language code for "Mandarin Traditional" */ 
    public static final ElvisLanguage MANDARIN_TRADITIONAL = new ElvisLanguage("zhtw", "Mandarin Traditional");

    /** Language code for "Finnish" */ 
    public static final ElvisLanguage FINNISH = new ElvisLanguage("fifi", "Finnish");

    /** Language code for "Turkish" */ 
    public static final ElvisLanguage TURKISH = new ElvisLanguage("trtr", "Turkish");

    /** Language code for "British English" */ 
    public static final ElvisLanguage BRITISH_ENGLISH = new ElvisLanguage("engb", "British English");

    /** Language code for "Latin American Spanish" */ 
    public static final ElvisLanguage LATIN_AMERICAN_SPANISH = new ElvisLanguage("esus", "Latin American Spanish");

    /** Language code for "Canadian French" */ 
    public static final ElvisLanguage CANADIAN_FRENCH = new ElvisLanguage("frca", "Canadian French");

    /** Language code for "Japanese" */ 
    public static final ElvisLanguage JAPANESE = new ElvisLanguage("jajp", "Japanese");

    /** Language code for "US Spanish" */ 
    public static final ElvisLanguage US_SPANISH = new ElvisLanguage("esus", "US Spanish");

    /** Language code for "United States English" */ 
    public static final ElvisLanguage UNITED_STATES_ENGLISH = new ElvisLanguage("enus", "United States English");

    /** Language code for "Mandarin/English Traditional" */ 
    public static final ElvisLanguage MANDARIN_ENGLISH_TRADITIONAL = new ElvisLanguage("zetw", "Mandarin/English Traditional");

    /** Language code for "Australian English" */ 
    public static final ElvisLanguage AUSTRALIAN_ENGLISH = new ElvisLanguage("enau", "Australian English");

    /** Language code for "Polish" */ 
    public static final ElvisLanguage POLISH = new ElvisLanguage("plpl", "Polish");

    /** Language code for "Swedish" */ 
    public static final ElvisLanguage SWEDISH = new ElvisLanguage("svse", "Swedish");

    /** Language code for "German" */ 
    public static final ElvisLanguage GERMAN = new ElvisLanguage("dede", "German");

    /** Language code for "Ukrainian" */ 
    public static final ElvisLanguage UKRAINIAN = new ElvisLanguage("ukua", "Ukrainian");

    /** Language code for "Unspecified" */ 
    public static final ElvisLanguage UNSPECIFIED = new ElvisLanguage("xxxx", "Unspecified");

    /** Language code for "Russian" */ 
    public static final ElvisLanguage RUSSIAN = new ElvisLanguage("ruru", "Russian");

    /** Language code for "Cantonese Simplified" */ 
    public static final ElvisLanguage CANTONESE_SIMPLIFIED = new ElvisLanguage("zhct", "Cantonese Simplified");

    /** Language code for "European Spanish" */ 
    public static final ElvisLanguage EUROPEAN_SPANISH = new ElvisLanguage("eses", "European Spanish");

    /** Language code for "Danish" */ 
    public static final ElvisLanguage DANISH = new ElvisLanguage("dadk", "Danish");

    /** Language code for "Dutch" */ 
    public static final ElvisLanguage DUTCH = new ElvisLanguage("nlnl", "Dutch");

    /** Language code for "Norwegian" */ 
    public static final ElvisLanguage NORWEGIAN = new ElvisLanguage("nono", "Norwegian");

    /** Language code for "Italian" */ 
    public static final ElvisLanguage ITALIAN = new ElvisLanguage("itit", "Italian");

    /** Language code for "Mandarin/English Simplified" */ 
    public static final ElvisLanguage MANDARIN_ENGLISH_SIMPLIFIED = new ElvisLanguage("zecn", "Mandarin/English Simplified");

    /** Language code for "Cantonese/English Traditional" */ 
    public static final ElvisLanguage CANTONESE_ENGLISH_TRADITIONAL = new ElvisLanguage("zehk", "Cantonese/English Traditional");

    /** Language code for "Cantonese/English Simplified" */ 
    public static final ElvisLanguage CANTONESE_ENGLISH_SIMPLIFIED = new ElvisLanguage("zect", "Cantonese/English Simplified");

    /** Language code for "European Portuguese" */ 
    public static final ElvisLanguage EUROPEAN_PORTUGUESE = new ElvisLanguage("ptpt", "European Portuguese");

    /** Language code for "Brazilian Portuguese" */ 
    public static final ElvisLanguage BRAZILIAN_PORTUGUESE = new ElvisLanguage("ptbr", "Brazilian Portuguese");

    /** Language code for "Greek" */ 
    public static final ElvisLanguage GREEK = new ElvisLanguage("elgr", "Greek");

    /** Language code for "Korean" */ 
    public static final ElvisLanguage KOREAN = new ElvisLanguage("kokr", "Korean");

    /** All languages */
    public static final ElvisLanguage[] ALL_LANGUAGES = { CANTONESE_TRADITIONAL, EUROPEAN_FRENCH, MANDARIN_TRADITIONAL, FINNISH, TURKISH, BRITISH_ENGLISH, LATIN_AMERICAN_SPANISH, CANADIAN_FRENCH, JAPANESE, US_SPANISH, UNITED_STATES_ENGLISH, MANDARIN_ENGLISH_TRADITIONAL, AUSTRALIAN_ENGLISH, POLISH, SWEDISH, GERMAN, UKRAINIAN, UNSPECIFIED, RUSSIAN, CANTONESE_SIMPLIFIED, EUROPEAN_SPANISH, DANISH, DUTCH, NORWEGIAN, ITALIAN, MANDARIN_ENGLISH_SIMPLIFIED, CANTONESE_ENGLISH_TRADITIONAL, CANTONESE_ENGLISH_SIMPLIFIED, EUROPEAN_PORTUGUESE, BRAZILIAN_PORTUGUESE, GREEK, KOREAN,  };
}
