package com.nuance.dragon.toolkit.elvis;

import java.util.ArrayList;
import java.util.List;

import com.nuance.dragon.toolkit.core.Word;
import com.nuance.dragon.toolkit.oem.api.Logger;

class NativeElvisImpersonator implements NativeElvis
{
    private boolean _recognizing;

    @Override
    public boolean listAvailableModels(List<NativeModelInfo> retModels)
    {
       return true;
    }

    @Override
    public int processAudio(short[] shorts)
    {
        Logger.debug(this, "Recorded " + shorts.length + " shorts");
        return _recognizing ? SPEECH : SPEECH_ENDED;
    }

    @Override
    public boolean createElvis(String language, int samplingRate, String binfile)
    {
        return true;
    }

    @Override
    public void destroyElvis()
    {
    }

    @Override
    public boolean recreateElvis(boolean force)
    {
        return true;
    }

    @Override
    public Grammar loadGrammar(String fileName)
    {
        return new Grammar();
    }

    @Override
    public boolean saveGrammar(String fileName, Grammar grammar)
    {
        return true;
    }

    @Override
    public int addConstraint(String name, int classCount, int transitionCount, boolean hasPenalty, boolean reset)
    {
        return CONSTRAINT_ADDED;
    }

    @Override
    public boolean constraintExists(String name)
    {
        return false;
    }

    @Override
    public boolean clearGrammar()
    {
        return false;
    }

    @Override
    public int addWordClass(WordSlot slot)
    {
        return WORDCLASS_ADDED;
    }

    @Override
    public int addWordClassMember(String wordclass, Word word, boolean addVariants)
    {
        return WORD_ADDED;
    }

    @Override
    public boolean removeWordClassMember(String wordclass, Word word)
    {
        // TODO Auto-generated method stub
        return true;
    }

    @Override
    public int addExternalPronunciation(Word word)
    {
        return WORD_ADDED;
    }

    @Override
    public int addTransition(String constraint, String fromWordClass, String toWordClass, int penalty)
    {
        return TRANSITION_ADDED;
    }

    @Override
    public boolean recognize(List<String> activeConstraints, boolean resetChannel)
    {
        _recognizing = true;
        return true;
    }

    @Override
    public boolean finishRecognizing(boolean abort)
    {
        _recognizing = false;
        return true;
    }

    @Override
    public boolean adapt(String phrase)
    {
        _recognizing = true;
        return true;
    }

    @Override
    public ElvisAdaptationResult processAdaptation()
    {
        return null;
    }

    @Override
    public boolean loadAdaptation(String fileName, String ext, boolean isUnsupervised)
    {
        return true;
    }

    @Override
    public boolean finishAdapting(String fileName, boolean abort)
    {
        return true;
    }

    @Override
    public boolean checkAdaptationStatus(String fileName)
    {
        return false;
    }

    @Override
    public boolean clearAdaptation(String fileName, String ext, boolean all)
    {
        return false;
    }

    @Override
    public ElvisResult getResult(Grammar grammar)
    {
        return new ElvisResult(new ElvisNbestList(new ArrayList<ElvisNbestList.Entry>(0)), ElvisResult.GATE_CONFIDENCE_UNAVAILABLE, ElvisResult.WAKEUP_TIMESTAMP_UNAVAILABLE, ElvisResult.WAKEUP_TIMESTAMP_UNAVAILABLE, ElvisResult.WAKEUP_TIMESTAMP_UNAVAILABLE, ElvisResult.WAKEUP_TIMESTAMP_UNAVAILABLE, ElvisResult.WakeupStatus.NO_COMMAND, null);
    }

    @Override
    public boolean wakeupMode(List<String> wakeupPhrases, int penalty, int mode, int commandStartBailoutMs, int commandEndBailoutMs, int commandMinSpeechMs, boolean autoAdapt)
    {
        return true;
    }

    @Override
    public int processWakeupAudio(short[] shorts, long timestamp) {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public boolean finishWakeupMode(String fileName) {
        return true;
    }

    @Override
    public int getSoundLevel()
    {
        return 0;
    }

    @Override
    public ElvisResult getWakeupResult(boolean seamless)
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public boolean checkWakeupPhrase(String wakeupPhrase)
    {
        return false;
    }

    @Override
    public boolean endpointingMode(int neededSamples, int ignoredSamples, boolean resetChannel, String loggingFolder)
    {
        return true;
    }

    @Override
    public int processEndpointingAudio(short[] shorts)
    {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public boolean finishEndpointing()
    {
        return true;
    }

    @Override
    public void releaseUnusedMemory()
    {
        // TODO Auto-generated method stub

    }

    @Override
    public boolean enableElvisRecognitionLogging(String logPrefix, int logMillis, String uuid)
    {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public int getElvisRecognitionLoggingStatus()
    {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public boolean copyElvisRecognitionLogs(String destinationFolder, String destinationPrefix)
    {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean deleteConstraint(String name)
    {
       // TODO Auto-generated method stub
       return false;
    }

    @Override
    public void enableElvisVerboseLogging(boolean verbose)
    {
       // TODO Auto-generated method stub

    }

    @Override
    public boolean logMiscInfo(String tag, String data)
    {
        return false;
    }

    @Override
    public int [] createBlob(List<String> phrases, int numPhrases, int decoyPenalty, boolean isMagic, int maxDuration)
    {
        return null;
    }


    @Override
    public int setTargetCPU(String cpu)
    {
        return 0;
    }

    @Override
    public int forgetBlob()
    {
        return 0;
    }

    @Override
    public int evaluateWakeupPhrase(String phrase)
    {
        return 0;
    }
}
