package com.nuance.dragon.toolkit.elvis;

import java.util.ArrayList;

class NbestEntryJni
{
    final String constraint;
    final int score;
    private final ArrayList<ElvisNbestList.Entry.Word> _words;

    NbestEntryJni(String constraint, int score)
    {
        this.constraint = constraint;
        this.score = score;
        _words = new ArrayList<ElvisNbestList.Entry.Word>();
    }

    void addWord(String wordSlot, String surfaceForm, String spokenForm, String fullPhrase, int[] wordIds, int phraseId)
    {
        _words.add(new ElvisNbestList.Entry.Word(wordSlot, surfaceForm, spokenForm, fullPhrase, wordIds, phraseId, false));
    }

    ArrayList<ElvisNbestList.Entry.Word> getWords()
    {
        return _words;
    }

    ElvisNbestList.Entry createRealEntry(Grammar grammar)
    {

        ElvisNbestList.Entry entry = new ElvisNbestList.Entry(constraint, this.score);
        for (ElvisNbestList.Entry.Word w : _words)
        {
            WordSlot ws = null;
            if (grammar != null) {
                ws = grammar.getWordSlotByName(w.wordSlot);
            }
            boolean isGeneric = ws != null && ws.isGeneric();

            if (!isGeneric)
                entry.addWord(w);
            else
                entry.addWord(new ElvisNbestList.Entry.Word(w.wordSlot, w.surfaceForm, w.spokenForm, w.fullPhrase, w.wordIds, true));
        }
        return entry;
    }
}
