package com.nuance.dragon.toolkit.hybrid;

import com.nuance.dragon.toolkit.cloudservices.TransactionError;

/**
 * A hybrid TTS error.
 */
public final class HybridTtsError
{
    private final TransactionError _transactionError;
    private final boolean _canceled;

    HybridTtsError(TransactionError transactionError, boolean canceled)
    {
        _transactionError = transactionError;
        _canceled = canceled;
    }

    /**
     * Get the transaction error.
     * @return The transaction error. May be null if the server TTS was not exercised.
     */
    public TransactionError getTransactionError()
    {
        return _transactionError;
    }

    /**
     * Indicates if the generation has been canceled.
     * @return True if the generation has been canceled, else false.
     */
    public boolean isCanceled()
    {
        return _canceled;
    }
}
