package com.nuance.dragon.toolkit.hybrid;

import com.nuance.dragon.toolkit.cloudservices.vocalizer.TtsSpec;
import com.nuance.dragon.toolkit.core.data.Data;

/**
 * Defines a Hybrid TTS request for {@link HybridVocalizer}.
 */
public class HybridTtsSpec
{
    private final TtsSpec _cloudSpec;
    private final Data.Dictionary _localSpec;

    /**
     * @param cloudSpec The cloud {@link TtsSpec}. May be null to only exercise the local TTS engine.
     * @param localSpec The local param data. May be null to never use the local TTS engine.
     */
    public HybridTtsSpec(TtsSpec cloudSpec,
                         Data.Dictionary localSpec)
    {
        _cloudSpec = cloudSpec;
        _localSpec = localSpec;
    }

    /**
     * @return The cloud TTS spec.
     */
    public TtsSpec getCloudSpec()
    {
        return _cloudSpec;
    }

    /**
     * @return The local spec.
     */
    public Data.Dictionary getLocalSpec()
    {
        return _localSpec;
    }
}
