package com.nuance.dragon.toolkit.language;

/**
 * Implemented by NMT but called by the application upon a language change
 * in order to simplify language switch operations across the recognition
 * back-ends (cloud, Elvis, VoCon).
 */
public abstract class LanguageEvent
{
    public interface Listener
    {
        /**
         * Language switching operation has been completed.
         * @param success false if the operation was unsuccessful.
         */
        void onComplete(boolean success);
    }

    /**
     * Called when the language is changed.
     * @param object A NMT object relevant to the context (ex: CloudServices). May be null.
     * @param listener Listener to be informed when the operation is done. May be null.
     */
    public abstract void onApplicationLanguageChange(Object object, Listener listener);
}
