package com.nuance.dragon.toolkit.nvsl;

class AudioInfoJni
{
    private final float _processedAudio;
    private final float _processedSpeech;
    private final float _totalAudioDuration;
    private final float _speechLevel;
    private final float _saturationLevel;
    private final float _snr;
    final boolean isAudioEnded;

    AudioInfoJni(float processedAudio, float processedSpeech, float totalAudioDuratioin,
                    float speechLevel, float saturationLevel, float snr, boolean isAudioEnded)
    {
        _processedAudio = processedAudio;
        _processedSpeech = processedSpeech;
        _totalAudioDuration = totalAudioDuratioin;
        _speechLevel = speechLevel;
        _saturationLevel = saturationLevel;
        _snr = snr;
        this.isAudioEnded = isAudioEnded;
    }

    NVSLAudioInfo createAudioInfo()
    {
        NVSLAudioInfo audioInfo = new NVSLAudioInfo();

        audioInfo.processedAudio = _processedAudio;
        audioInfo.processedSpeech = _processedSpeech;
        audioInfo.totalAudioDuration = _totalAudioDuration;
        audioInfo.speechLevel = _speechLevel;
        audioInfo.saturationLevel = _saturationLevel;
        audioInfo.snr = _snr;

        return audioInfo;
    }
}
