package com.nuance.dragon.toolkit.oem.api;

import java.util.Map;

public interface HttpUtil
{
	static final String PROTOCOL_CHARSET = "utf-8";
	public static final String PROTOCOL_CONTENT_TYPE_JSON = String.format("application/json; charset=%s", PROTOCOL_CHARSET);
	public static final String PROTOCOL_CONTENT_TYPE_OAUTH = String.format("application/x-www-form-urlencoded");

	public static final int METHOD_GET  = 0;
	public static final int METHOD_POST = 1;

	public static class HttpConnectionStatus
	{
		private HttpConnectionStatus() {}
		public static final HttpConnectionStatus HTTP_CONNECTION_OK    = new HttpConnectionStatus();   /*!< Requested operation succeeded */
		public static final HttpConnectionStatus HTTP_CONNECTION_ERROR = new HttpConnectionStatus();   /*!< Requested operation failed */
		public static final HttpConnectionStatus HTTP_CONNECTION_ERROR_SECURITY = new HttpConnectionStatus();   /*!< Requested operation failed due to security */
	}

	public interface ResponseCallback
	{
		void okCallback(String response);
		void errorCallback(HttpConnectionStatus status, int responseCode, String response);
	}

	public void request(int method, String url, String requestBodyContentType, String requestBody, ResponseCallback responseCallback);
	public void request(int method, String url, String requestBodyContentType, String requestBody, final ResponseCallback responseCallback, final Map<String, String> extraHeaders);
	
	public void release();
}
