package com.nuance.dragon.toolkit.oem.api;

import org.json.JSONObject;

/**
 * Interface for objects that can be represented by JSON.
 * <p>
 * Note: there is no 'fromJSON()' method. Any class that can be created from
 * JSON may have its own static creation method or constructor, but it is not
 * part of this interface.
 */
public interface JSONCompliant
{
    /**
     * Get the JSON representation of the object.
     * @return A new JSON object representing the object.
     */
    JSONObject toJSON();
}
