package com.nuance.dragon.toolkit.oem.api;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public interface NMTAssetFileDescriptor
{
    /**
     * Create and return a new auto-close input stream for this asset.
     *
     * @throws IOException
     */
    FileInputStream createInputStream();

    /**
     * Create and return a new auto-close output  stream for this asset.
     *
     * @throws IOException
     */
    FileOutputStream createOutputStream ();

    /**
     * Closes the underlying OS resources allocated to represent this stream.
     *
     * @throws IOException
     */
    void close();

    /**
     * Return the actual number of bytes that were declared when the file descriptor was constructed.
     */
    long getDeclaredLength();

    /**
     * Get native asset file descriptor
     * @return on Android returns AssetFileDescriptor; on J2SE returns File Object
     */
    Object getNativeDescriptor();
}
