package com.nuance.dragon.toolkit.oem.api.json;

import java.util.Collection;

import org.json.JSONException;
import org.json.JSONTokener;

import com.nuance.dragon.toolkit.oem.api.JSONCompliant;
import com.nuance.dragon.toolkit.oem.api.Logger;

//TODO need comments
public class JSONArray extends org.json.JSONArray
{
    public JSONArray(org.json.JSONArray json)
    {
        for (int i = 0; i < json.length(); i++)
        {
            try
            {
                Object o = json.get(i);
                put(i, o);
            } catch (JSONException e)
            {
                Logger.error(this, "Error creating JSONArray", e);
            }
        }
    }

    public JSONArray(Collection<Object> copyFrom)
    {
        super(copyFrom);
    }

    public JSONArray(JSONTokener readFrom) throws JSONException
    {
        super(readFrom);
    }

    public JSONArray(String json) throws JSONException
    {
        super(json);
    }

    public JSONArray()
    {
        super();
    }

    /**
     * Like {@link org.json.JSONArray#put(int, Object)}, but reports errors via
     * return value instead of exception.
     *
     * @param index
     * @param value
     * @return true if successful, false otherwise.
     */
    public boolean tryPut(int index, Object value)
    {
        try
        {
            put(index, value);
            return true;
        } catch (JSONException e)
        {
            Logger.error(this, "Error adding to JSONArray");
        }
        return false;
    }

    /**
     * Like {@link org.json.JSONArray#put(Object)}, but reports errors via
     * return value instead of exception.
     *
     * @param value
     * @return true if successful, false otherwise.
     */
    public boolean tryPut(Object value)
    {
        if (value instanceof JSONCompliant)
        {
            value = ((JSONCompliant)value).toJSON();
        }

        put(value);
        return true;
    }
}
