package com.nuance.dragon.toolkit.oem.impl;

import android.os.Handler;
import android.os.Looper;

import com.nuance.dragon.toolkit.oem.api.NMTHandler;
import com.nuance.dragon.toolkit.oem.api.internal.Checker;

public class HandlerOem implements NMTHandler
{
	private final Handler _handler;

	public HandlerOem()
	{
		this(false);
	}

	public HandlerOem(Object obj)
	{
		 Checker.checkState(obj, (obj instanceof Handler), "HandlerOem is expecting android.os.Handler in constructor");
		_handler = (Handler)obj;
	}

    public HandlerOem(boolean isMain)
    {
        if (isMain)
        {
        	_handler = new Handler(Looper.getMainLooper());
        }
        else
        {
        	_handler = new Handler();
        }
    }

	@Override
	public boolean post(Runnable r)
	{
		if (_handler != null)
		{
			return _handler.post(r);
		}
		return false;
	}

	@Override
	public boolean postDelayed(Runnable r, long delayMillis)
	{
		if (_handler != null)
		{
			return _handler.postDelayed(r, delayMillis);
		}
		return false;
	}

	@Override
	public void removeCallbacks(Runnable r)
	{
		if (_handler != null)
		{
			_handler.removeCallbacks(r);
		}
	}

	@Override
	public Object getNativeHandler()
	{
		return _handler;
	}

    @Override
    public boolean postToLooper(Runnable r) {
        r.run();
        return false;
    }
}
