package com.nuance.dragon.toolkit.oem.impl;

import android.os.Looper;

import com.nuance.dragon.toolkit.oem.api.NMTHandler;
import com.nuance.dragon.toolkit.oem.api.WorkerThread;
import com.nuance.dragon.toolkit.oem.api.internal.Checker;
import com.nuance.dragon.toolkit.util.internal.AttachableHandler;


public class WorkerThreadOem implements WorkerThread
{
    private final AttachableHandler _handler;
    private final Thread _thread;

    public WorkerThreadOem()
    {
        this("com.nuance.dragon.toolkit.util.WorkerThread");
    }

    public WorkerThreadOem(String threadName)
    {
        Checker.checkStringArgForNullOrEmpty("threadName", threadName);

        _handler = new AttachableHandler();
        _thread = new Thread(new Runnable()
        {
            @Override
            public void run()
            {
                Looper.prepare();
                _handler.attachToCurrentThread();
                Looper.loop();
            }
        }, threadName);
    }

    public void start()
    {
        _thread.start();
    }

    public void stop()
    {
        _handler.post(new Runnable()
        {
            @Override
            public void run()
            {
                Looper.myLooper().quit();
            }
        });
    }

    public NMTHandler getHandler()
    {
        return new HandlerOem(_handler);
    }

    public Thread getThread()
    {
        return _thread;
    }

	@Override
	public void addRunnable(Runnable r)
	{
	}

	@Override
	public void removeRunnable(Runnable r)
	{
	}
}
