package com.nuance.dragon.toolkit.recognition;

/**
 * Combines 2 recognitions into a single one (e.g. in a hybrid scenario).
 */
public interface InterpretedRecognitionCombiner
{
    /**
     * Combine the two results.
     * @param recognition1
     * @param recognition2
     * @return A new recognition--never null.
     * @throws InterpretException Thrown if there was an error combining the recognitions.
     */
    InterpretedRecognition combine(InterpretedRecognition recognition1,
                                   InterpretedRecognition recognition2) throws InterpretException;
}
