package com.nuance.dragon.toolkit.recognition.dictation.internal;

import com.nuance.dragon.toolkit.recognition.dictation.EditorItem;


class Word implements EditorItem
{
    private String _text;
    private Type _type;

    public Word(String text, Type type) throws IllegalArgumentException
    {
        if (text == null && type == Type.WORD) {
            throw new IllegalArgumentException("Text cannot be null!");
        }
        _type = type;

        if (_type == Type.WHITE_SPACE) {
            _text = " ";
        }
        else {
            _text = text;
        }

    }

    @Override
    public int length() {
        return _text.length();
    }

    @Override
    public Type getType() {
        return _type;
    }

    @Override
    public String toString()
    {
        return _text;
    }
}
