package com.nuance.dragon.toolkit.util.internal;

public class ObjectUtils
{
    /**
     * Determine whether two objects are equal. This safely handles null values.
     * @param o1
     * @param o2
     * @return True if the objects are the same (either both == null, or .equals() returns true)
     */
    public static boolean compareObjects(Object o1, Object o2)
    {
        if (o1 == null)
            return o1 == o2;

        if (o2 == null)
            return false;

        return o1.equals(o2);
    }

    /**
     * Create a sub-array of the given array
     * @param input The input array
     * @param offset The offset in the input array to begin the output array
     * @param length The size of the output array
     * @return The sub-array
     */
    public static byte[] createSubArray(byte[] input, int offset, int length)
    {
        if (offset + length > input.length)
            length = input.length - offset;

        byte[] ret = new byte[length];
        System.arraycopy(input, offset, ret, 0, length);
        return ret;
    }

    /**
     * Create a sub-array of the given array
     * @param input The input array
     * @param offset The offset in the input array to begin the output array
     * @param length The size of the output array
     * @return The sub-array
     */
    public static short[] createSubArray(short[] input, int offset, int length)
    {
        if (offset + length > input.length)
            length = input.length - offset;

        short[] ret = new short[length];
        System.arraycopy(input, offset, ret, 0, length);
        return ret;
    }
}
