package com.nuance.dragon.toolkit.util.internal;

public class Pair<F, S> {
    public final F first;
    public final S second;

    public Pair(F first, S second)
    {
        this.first = first;
        this.second = second;
    }

    @Override
    public boolean equals(Object o)
    {
        if (!(o instanceof Pair))
        {
            return false;
        }
        Pair<?, ?> p = (Pair<?, ?>) o;
        return ObjectUtils.compareObjects(p.first, first) && ObjectUtils.compareObjects(p.second, second);
    }

    @Override
    public int hashCode()
    {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((first == null) ? 0 : first.hashCode());
        result = prime * result + ((second == null) ? 0 : second.hashCode());
        return result;
    }
}
