package com.nuance.dragon.toolkit.util.internal;

import java.util.ArrayList;

public class StringUtils
{
    /**
     * Joins the {@link Object#toString} of an array of objects.
     * @param array The array of objects to join.
     * @param joiner The text to insert between objects.
     * @return The joined string
     */
    public static String joinStrings(Iterable<? extends Object> array, String joiner)
    {
        StringBuffer buffer = new StringBuffer();
        boolean first = true;
        for (Object o : array)
        {
            if (!first)
                buffer.append(joiner);
            else
                first = false;
            buffer.append(o.toString());
        }
        return buffer.toString();
    }

    /**
     * Split a string on a character
     * @param text
     * @param splitToken
     * @return An array of strings
     */
    public static String[] splitString(String text, char splitToken)
    {
        ArrayList<String> results = new ArrayList<String>();
        int index = 0;
        do {
            int newIndex = text.indexOf(splitToken, index);
            if (newIndex >= 0)
            {
                results.add(text.substring(index, newIndex));
                index = newIndex+1;
            } else
            {
                results.add(text.substring(index, text.length()));
            }
            index = newIndex + 1;
        } while (index > 0);

        return (String[])results.toArray();
    }

    /**
     * Append two strings. If one is null, the other is returned. If both are
     * null, null is returned. If neither is null, a + b is returned.
     * @param a
     * @param b
     * @return The concatenation, or null if both are null.
     */
    public static String appendWithNulls(String a, String b)
    {
        if (a == null)
            return b;
        if (b == null)
            return a;

        return a + b;
    }
}
