package com.nuance.dragon.toolkit.util.internal;

import com.nuance.dragon.toolkit.oem.api.Logger;


public final class ThreadUtils
{
    /**
     * A very simple wrapper around {@link #Thread.sleep(long)} that catches the exception.
     * @param time The time to sleep in milliseconds.
     */
    public static void sleep(long time)
    {
        try {
            Logger.verbose(ThreadUtils.class, "Sleeping for " + time + " ms.");
            Thread.sleep(time);
        } catch (InterruptedException e) {
            Logger.error(ThreadUtils.class, "Failed to sleep " + time + " ms.", e);
        }
    }
}
