package com.nuance.dragon.toolkit.vocalizer;

/**
 * Information about a supported Vocalizer model.
 */
public final class VocalizerModelInfo
{
    /** The voice */
    public final VocalizerVoice voice;
    /** The frequency: 8, 16, or 22 */
    public final int frequencyKhz;
    /** The model information */
    public final String model;

    VocalizerModelInfo(VocalizerVoice voice, int freqKhz, String model)
    {
        this.voice = voice;
        this.frequencyKhz = freqKhz;
        this.model = model;
    }

    @Override
    public String toString()
    {
        return voice.toString() + ", " + frequencyKhz + "KHz, " + model;
    }
}
