package com.nuance.dragon.toolkit.vocon;

public class FileOperationResult {

    /**
     * The result status.
     */
    public static enum OperationResult
    {
        SUCCESS,
        FAILURE
    }

    FileOperationResult(String fileName, OperationResult result)
    {
        _fileName = fileName;
        _result = result;
    }

    /**
     * Get the name of the file that was the subject of this save operation
     * @return The file name.
     */
    public String getFileName()
    {
        return _fileName;
    }

    /**
     * Get the result of the save operation.
     * @return The result. See {@link OperationResult} for possible values.
     */
    public OperationResult getOperationResult()
    {
        return _result;
    }

    private String _fileName;
    private OperationResult _result;
}
