package com.nuance.dragon.toolkit.vocon;

import java.util.regex.Matcher;

/** This file was automatically generated by TODO 'create_vocon_config_classes.py'. */
class LangSpecs {
    private static final String ACMODFILE_FORMAT = "acmod(\\d+)_~size_kb~_~language~_([a-z]+)_([a-z]+)_f(\\d+)(.*)\\.dat";
    static final String ACMODFILE_REGEX = "acmod(\\d+)_(\\d+)_([a-z]{3})_([a-z]+)_([a-z]+)_f(\\d+)(.*)\\.dat";

    private static final String CLCFILE_FORMAT = "clc_~language~_~domain~(.*)\\.dat";
    static final String CLCFILE_REGEX = "clc_([a-z]{3})_([a-z0-9]+)(.*)\\.dat";

    static String getAcmodFileNameRegEx(String language, int sizeKb)
    {
        return ACMODFILE_FORMAT.replace("~language~", language).replace("~size_kb~", String.valueOf(sizeKb));
    }

    static String getMatchedAcmodFileLanguage(Matcher matcher)
    {
        return matcher.group(3);
    }

    static String getMatchedAcmodFileSizeKb(Matcher matcher)
    {
        return matcher.group(2);
    }

    static String getClcFileNameRegEx(String language, String domain)
    {
        return CLCFILE_FORMAT.replace("~language~", language).replace("~domain~", domain);
    }

    static String getMatchedClcFileLanguage(Matcher matcher)
    {
        return matcher.group(1);
    }

    static String getMatchedClcFileDomain(Matcher matcher)
    {
        return matcher.group(2);
    }


    /** Language code for "European French" */
    public static final VoconLanguage EUROPEAN_FRENCH = new VoconLanguage("frf", "European French");

    /** Language code for "Canadian French" */
    public static final VoconLanguage CANADIAN_FRENCH = new VoconLanguage("frc", "Canadian French");

    /** Language code for "Finnish" */
    public static final VoconLanguage FINNISH = new VoconLanguage("fif", "Finnish");

    /** Language code for "British English" */
    public static final VoconLanguage BRITISH_ENGLISH = new VoconLanguage("eng", "British English");

    /** Language code for "Australian English" */
    public static final VoconLanguage AUSTRALIAN_ENGLISH = new VoconLanguage("ena", "Australian English");

    /** Language code for "United States English" */
    public static final VoconLanguage UNITED_STATES_ENGLISH = new VoconLanguage("enu", "United States English");

    /** Language code for "Japanese" */
    public static final VoconLanguage JAPANESE = new VoconLanguage("jpj", "Japanese");

    /** Language code for "Korean" */
    public static final VoconLanguage KOREAN = new VoconLanguage("kok", "Korean");

    /** Language code for "European Spanish" */
    public static final VoconLanguage EUROPEAN_SPANISH = new VoconLanguage("spe", "European Spanish");

    /** Language code for "Mexican Spanish" */
    public static final VoconLanguage MEXICAN_SPANISH = new VoconLanguage("spm", "Spanish Mexico");

    /** Language code for "US Spanish" */
    public static final VoconLanguage US_SPANISH = new VoconLanguage("spu", "US Spanish");

    /** Language code for "Swedish" */
    public static final VoconLanguage SWEDISH = new VoconLanguage("sws", "Swedish");

    /** Language code for "Russian" */
    public static final VoconLanguage RUSSIAN = new VoconLanguage("rur", "Russian");

    /** Language code for "European Portuguese" */
    public static final VoconLanguage EUROPEAN_PORTUGUESE = new VoconLanguage("ptp", "European Portuguese");

    /** Language code for "Brazilian Portuguese" */
    public static final VoconLanguage BRAZILIAN_PORTUGUESE = new VoconLanguage("ptb", "Brazilian Portuguese");

    /** Language code for "Polish" */
    public static final VoconLanguage POLISH = new VoconLanguage("plp", "Polish");

    /** Language code for "German" */
    public static final VoconLanguage GERMAN = new VoconLanguage("ged", "German");

    /** Language code for "Dutch" */
    public static final VoconLanguage DUTCH = new VoconLanguage("dun", "Dutch");

    /** Language code for "Mandarin/English Traditional" */
    //TODO

    /** Language code for "Cantonese/English Traditional" */
    //TODO

    /** Language code for "Mandarin/English Simplified" */
    //TODO

    /** Language code for "Cantonese/English Simplified" */
    //TODO

    /** Language code for "Cantonese Simplified" */
    public static final VoconLanguage CANTONESE_SIMPLIFIED = new VoconLanguage("cac", "Cantonese Simplified");

    /** Language code for "Cantonese Traditional" */
    public static final VoconLanguage CANTONESE_TRADITIONAL = new VoconLanguage("cah", "Cantonese Traditional");

    /** Language code for "Mandarin Traditional" */
    public static final VoconLanguage MANDARIN_TRADITIONAL = new VoconLanguage("mnt", "Mandarin Traditional");

    /** Language code for "Mandarin Simplified" */
    public static final VoconLanguage MANDARIN_SIMPLIFIED = new VoconLanguage("mnc", "Mandarin Simplified");

    /** Language code for "Ukrainian" */
    public static final VoconLanguage UKRAINIAN = new VoconLanguage("uku", "Ukrainian");

    /** Language code for "Danish" */
    public static final VoconLanguage DANISH = new VoconLanguage("dad", "Danish");

    /** Language code for "Norwegian" */
    public static final VoconLanguage NORWEGIAN = new VoconLanguage("non", "Norwegian");

    /** Language code for "Italian" */
    public static final VoconLanguage ITALIAN = new VoconLanguage("iti", "Italian");

    /** Language code for "Greek" */
    public static final VoconLanguage GREEK = new VoconLanguage("grg", "Greek");

    /** Language code for "Turkish" */
    public static final VoconLanguage TURKISH = new VoconLanguage("trt", "Turkish");

    /** Language code for "Unspecified" */
    public static final VoconLanguage UNSPECIFIED = new VoconLanguage("xxx", "Unspecified");

    /** All languages */
    public static final VoconLanguage[] ALL_LANGUAGES = { CANTONESE_TRADITIONAL, EUROPEAN_FRENCH, FINNISH, BRITISH_ENGLISH, AUSTRALIAN_ENGLISH, JAPANESE, SWEDISH, RUSSIAN, EUROPEAN_PORTUGUESE, POLISH, GERMAN, DUTCH, MANDARIN_TRADITIONAL, CANADIAN_FRENCH, US_SPANISH, UNITED_STATES_ENGLISH, EUROPEAN_SPANISH, MEXICAN_SPANISH, BRAZILIAN_PORTUGUESE, UKRAINIAN, CANTONESE_SIMPLIFIED, DANISH, NORWEGIAN, ITALIAN, MANDARIN_SIMPLIFIED, GREEK, KOREAN, TURKISH, UNSPECIFIED};
}
