package com.nuance.dragon.toolkit.vocon;

/**
 * The various pronunciation domains supported by Vocon via the Common Language Component (CLC).
 */
public final class VoconDomain
{
    /** Unspecified. Vocon engine will then load the best CLC available. */
    public final static String UNSPECIFIED = "unspecified";

    /** Training domain */
    public final static String TRAINING = "vadvde";

    /** Normal (i.e default) domain. */
    public final static String NORMAL = "cfg1";

    /** Normal + name domain. */
    public final static String NAME = "cfg3";

    /** Normal + music domain. */
    public final static String MUSIC = "mpthree";

    /** Normal + music + name domain. */
    public final static String SUPER_CLC = "mpthreevad";

    /** Normal + music + name domain with multi-lingual abilities (i.e "Super CLC"). */
    public final static String SUPER_CLC_ML = "mpthreevadml";
}
