package com.nuance.dragon.toolkit.vocon;

/**
 * A recognition tuning parameter being passed to the Vocon engine.
 */
public class VoconParam
{
    /**
     * Vocon parameter types.
     */
    class Type
    {
        /** Indicate a recognizer front-end parameter.
         *  Note: It can also be used on the native recognizer object
         *  Since the FX and REC are bundled altogether in our VoCon
         *  native implementation.
         */
        public final static int FRONT_END = 0;

        /** Indicate a recognition context parameter. */
        public final static int CONTEXT = 1;
    }

    /** The parameter ID */
    final Integer id;
    /** The parameter type from {@link VoconParam.Type} */
    final Integer type;

    /** The parameter name */
    final String name;

    VoconParam(Integer id, Integer type, String name)
    {
        this.id = id;
        this.type = type;
        this.name = name;
    }
}
