/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client.sdk.common.oem.api;

import com.nuance.nmsp.client.sdk.oem.MiscSystemOEM;


public abstract class MiscSystem
{
	private static MiscSystem instance = new MiscSystemOEM();
	
	protected abstract byte[] HMAC_SHA1_impl(byte[] key, byte[] data);
	protected abstract byte[] HMAC_SHA1_impl(byte[] key, byte[] data, int offset);
	
	public static byte[] HMAC_SHA1(byte[] key, byte[] data)
	{
		return MiscSystem.instance.HMAC_SHA1_impl(key, data);
	}
	
	public static byte[] HMAC_SHA1(byte[] key, byte[] data, int offset)
	{
		return MiscSystem.instance.HMAC_SHA1_impl(key, data, offset);
	}
	
	protected abstract String newUUID_impl();
	
	public static String newUUID()
	{
	    return MiscSystem.instance.newUUID_impl();
	}
}
