package com.nuance.nmsp.client.sdk.common.util;

public final class ClassUtils
{   
    /**
     * Get the short name of a class.
     * @param c The class.
     * @return The short name, or null if there isn't one.
     */
    public static String getShortClassName(Class<?> c)
    {
        String name = c.getSimpleName();
        if (name == null)
            return null;
        
        if (name.length() > 0)
            return name;
        
        name = c.getName();
        if (name == null)
            return null;
        
        int lastPeriod = name.lastIndexOf('.');
        if (lastPeriod >= 0 && ++lastPeriod < name.length())
        {
            name = name.substring(lastPeriod);
        }
        return name;
    }
}
