/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client.sdk.components.resource.internal.common;

public interface NMSPSessionListener {

    public void onSessionConnected(byte[] sessionId);

    public void onSessionDisconnected(short reasonCode);

    public void onBcpResponse(byte transactionId, long requestId, short statusCode, short requestState, short completionCause);
            
    public void onBcpSetParamsComplete(byte transactionId, long requestId, short statusCode, byte[] result);
    
    public void onBcpGetParamsComplete(byte transactionId, long requestId, short statusCode, byte[] result);
    
    public void onBcpEvent(byte transactionId, short eventCode);
    
    public void onBcpGenerateAudioComplete(byte transactionId, long requestId, long audioId, short completionCause);

    public void onBcpRecognitionIntermediateResults(byte transactionId, long requestId, short completionCause, byte[] recResult);

    public void onBcpRecognitionComplete(byte transactionId, long requestId, short completionCause, byte[] recResult);
    
    public void onBcpData(byte transactionId, long requestId, byte[] data);
    
    public void onBcpFreeResourceId();
    
    public void onMsgSent(String context, Object data);
    
    public void onMsgNotSent(String context, Object data);

    public void onVapSending();
    
    public void onVapPlayBeginReceived();
    
    public void onVapPlayReceived();
    
    public void onVapPlayEndReceived();
}
