/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client.sdk.components.resource.internal.nmas;

//#ifdef NMSP_LOG2
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory;
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory.Log;
//#endif
import com.nuance.nmsp.client.sdk.components.core.internal.pdx.PDXDictionary;
import com.nuance.nmsp.client.sdk.components.resource.nmas.Parameter;

public class PDXSeqParam extends PDXParam implements Parameter {
    //#ifdef NMSP_LOG2
//@    private static final Log log = LogFactory.getLog(PDXSeqParam.class);
    //#endif

    private PDXDictionary dict;

    public static final byte SEQ_START = 0x01;
    public static final byte SEQ_CHUNK = 0x02;
    public static final byte SEQ__END = 0x03;

    public PDXSeqParam(String name, PDXDictionary dict, byte type) {
        super(name);
        //#ifdef NMSP_LOG2
//@        log.debug("PDXSeqParam() " + name);
        //#endif
        if (type == SEQ_START) {
            super.setType(PDXParam.SEQ_PARAMETER_START);
        } else if (type == SEQ_CHUNK) {
            super.setType(PDXParam.SEQ_PARAMETER_CHUNK);
        } else {
            super.setType(PDXParam.SEQ_PARAMETER_END);
        }
        this.dict = dict;
    }

    protected byte[] getContent() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXSeqParam.getContent()");
        //#endif
        return this.dict.getContent();
    }
}
