/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client.sdk.components.resource.internal.nmas;

//#ifdef NMSP_LOG2
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory;
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory.Log;
//#endif
import com.nuance.nmsp.client.sdk.components.core.internal.pdx.PDXDictionary;
import com.nuance.nmsp.client.sdk.components.general.NMSPAudioSink;
import com.nuance.nmsp.client.sdk.components.resource.internal.common.NMSPSession;
import com.nuance.nmsp.client.sdk.components.resource.nmas.Parameter;

public class PDXTTSParam extends PDXParam implements Parameter {
    //#ifdef NMSP_LOG2
//@    private static final Log log = LogFactory.getLog(PDXTTSParam.class);
    //#endif

    private PDXDictionary tts_dict;
    private NMSPAudioSink audioSink;
    private int audioId;

    public PDXTTSParam(String name, NMSPSession session, PDXDictionary tts_dict, NMSPAudioSink audioSink) {
        super(name, PDXParam.TTS_PARAMETER);
        //#ifdef NMSP_LOG2
//@        log.debug("PDXTTSParam()");
        //#endif
        this.tts_dict = tts_dict;
        this.audioSink = audioSink;
        this.audioId = session.getNewAudioId();
        tts_dict.addInteger("audio_id", this.audioId);
    }

    protected int getAudioId() {
    	return this.audioId;
    }
    
    protected byte[] getContent() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXTTSParam.getContent()");
        //#endif
        return this.tts_dict.getContent();
    }

    protected NMSPAudioSink getAudioSink() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXTTSParam.getAudioSink()");
        //#endif
        return this.audioSink;
    }
}
