package com.nuance.nmsp.client.sdk.oem;

import java.util.Vector;

import com.nuance.nmsp.client.sdk.components.general.Parameter;

public interface EndPointer {
	
	public static final String VST_OEM_AUDIO_VAD_STOP_ON_END_OF_SPEECH = "ep.enable";
	public static final String VST_OEM_AUDIO_VAD_HISTORY_LEN = "ep.VadHistoryLength";
	public static final String VST_OEM_AUDIO_VAD_BEGIN_LEN = "ep.VadBeginLength"; 
	public static final String VST_OEM_AUDIO_VAD_BEGIN_THRESHOLD = "ep.VadBeginThreshold";
	public static final String VST_OEM_AUDIO_VAD_BEGIN_DELAY = "ep.VadBeginDelay";
	public static final String VST_OEM_AUDIO_VAD_END_LEN = "ep.VadEndLength";
	public static final String VST_OEM_AUDIO_VAD_END_THRESHOLD = "ep.VadEndThreshold";
	public static final String VST_OEM_AUDIO_VAD_INTERSPEECH_LEN = "ep.VadInterSpeechLength";
	public static final String VST_OEM_AUDIO_VAD_LONG_UTTERANCE = "ep.VadLongUtterance";

	public static final int VST_OEM_AUDIO_VAD_HISTORY_LEN_DEFAULT = 50;
	public static final int VST_OEM_AUDIO_VAD_BEGIN_LEN_DEFAULT = 15;
	public static final int VST_OEM_AUDIO_VAD_BEGIN_THRESHOLD_DEFAULT = 7;
	public static final int VST_OEM_AUDIO_VAD_BEGIN_DELAY_DEFAULT = 0;
	public static final int VST_OEM_AUDIO_VAD_END_LEN_DEFAULT = 50;
	public static final int VST_OEM_AUDIO_VAD_END_THRESHOLD_DEFAULT = 5;
	public static final int VST_OEM_AUDIO_VAD_INTERSPEECH_LEN_DEFAULT = 35;
	public static final int VST_OEM_AUDIO_VAD_LONG_UTTERANCE_DEFAULT = 0;
	
	public static final int VST_OEM_AUDIO_VAD_STOP_ON_END_OF_SPEECH_DEFAULT = 0;
//	private static final int VST_OEM_AUDIO_VAD_STOP_ON_END_OF_SPEECH_DEFAULT = 1;
	
	public static class EpType {
		private int value = 1;
		private EpType(int val) {value = val;};		
		public static final EpType DETECT_NOTHING = new EpType(1);
		public static final EpType SPEECH_END = new EpType(2);
		public static final EpType SPEECH_START = new EpType(3);
		public static final EpType DETECT_ERROR = new EpType(4);
		public static final EpType SPEECH_ONGOING = new EpType(5);
		
		public static EpType getEpType(int val) {
			if (SPEECH_END.value == val)
				return SPEECH_END;
			else if (SPEECH_START.value == val)
				return SPEECH_START;
			return DETECT_NOTHING;
		}
		public String toString(){
			return String.valueOf(value);
		}
	} 
	
	public void initialize(Vector audioParams);

	public boolean isEndPointingActive();
	/*------------------------------------------------------------------------
	 *
	 * VAD detection (e.g. nothing, end or start of speech)
	 *
 	------------------------------------------------------------------------*/
	public EpType detectEndPointing(short[] data);
	
	public void resetEndpointingDetection();
}
