/*------------------------------------------------------------------------

  Copyright 2006-2011 Nuance Communications, Inc.

------------------------------------------------------------------------*/
/**
 * Filename: AndroidVersion.java
 *
 *
 *
 *
 *
 */
package com.nuance.nmsp.client.sdk.oem.bluetooth;

import java.lang.reflect.Field;

import android.os.Build;

@SuppressWarnings("deprecation")
public class AndroidVersion {

    public  static final int SDK;
    public  static final String MANUFACTURER;
    public  static final boolean IS_BROKEN_SAMSUNG;
    public  static final boolean IS_BROKEN_HTC;
    public  static final boolean IS_BROKEN_MOTOROLA_i1;
    private static final boolean IS_BROKEN_SAMSUNG_FROYO;
    public  static final boolean USE_MUSIC_STREAM_FOR_BLUETOOTH;
    public  static final boolean HAS_WORKING_A2DP_CONTROL;
    private static final boolean IS_BROKEN_MOTOROLA_MB860;
    public  static final boolean FIX_FOR_GARBLED_BLUETOOTH_AUDIO;
    public  static final boolean SKIP_INITIATE_SPP_CONNECTION;

    public static final int BASE = 1;
    public static final int BASE_1_1 = 2;
    public static final int CUPCAKE = 3;
    public static final int DONUT = 4;
    public static final int ECLAIR = 5;
    public static final int ECLAIR_0_1 = 6;
    public static final int ECLAIR_MR1 = 7;
    public static final int FROYO = 8;
    public static final int GINGERBREAD = 9;
    public static final int GINGERBREAD_MR1 = 10;
    public static final int HONEYCOMB = 11;     // 3.0
    public static final int HONEYCOMB_MR1 = 12; // 3.1
    public static final int HONEYCOMB_MR2 = 13; // 3.2
    public static final int ICE_CREAM_SANDWICH = 14; // 4.0, 4.0.1, 4.0.2
    public static final int ICE_CREAM_SANDWICH_MR1 = 15; // 4.0.3
    public static final int JELLY_BEAN_4_1 =  16; // 4.1
    public static final int JELLY_BEAN_4_2 = 17; // 4.2
    
    
    public static final int CUR_DEVELOPMENT = 10000;

    static {
        SDK = Integer.parseInt(Build.VERSION.SDK);

        String manufacturer;
        try {
            Field manufacturerField = Build.class.getField("MANUFACTURER");
            manufacturer = (String) manufacturerField.get(null);
        } catch(Exception e) {
            manufacturer = "";
        }
        MANUFACTURER = manufacturer;
        final String model = Build.MODEL;

        IS_BROKEN_SAMSUNG = manufacturer.equalsIgnoreCase("samsung") && (model.equalsIgnoreCase("SGH-T959")
                                                                         || model.equalsIgnoreCase("SAMSUNG-SGH-I897")
                                                                         || model.equalsIgnoreCase("SGH-I897")
                                                                         || model.equalsIgnoreCase("GT-I9000"));
        IS_BROKEN_HTC = manufacturer.equalsIgnoreCase("htc") && (model.equalsIgnoreCase("PC36100")
                                                                 || model.equalsIgnoreCase("ADR6300")
                                                                 || model.equalsIgnoreCase("HTC Glacier")
                                                                 || model.equalsIgnoreCase("T-Mobile myTouch 4G")
                                                                 || model.equalsIgnoreCase("T-Mobile G2"));

        IS_BROKEN_MOTOROLA_i1 = model.equalsIgnoreCase("Motorola_i1");
        IS_BROKEN_MOTOROLA_MB860 = manufacturer.equalsIgnoreCase("Motorola")
                                   && model.equalsIgnoreCase("MB860");

        IS_BROKEN_SAMSUNG_FROYO = manufacturer.equalsIgnoreCase("samsung") && (SDK == FROYO);
        SKIP_INITIATE_SPP_CONNECTION = IS_BROKEN_SAMSUNG_FROYO;

        USE_MUSIC_STREAM_FOR_BLUETOOTH = IS_BROKEN_SAMSUNG || IS_BROKEN_MOTOROLA_i1;
        HAS_WORKING_A2DP_CONTROL = !IS_BROKEN_SAMSUNG;
        FIX_FOR_GARBLED_BLUETOOTH_AUDIO = IS_BROKEN_MOTOROLA_MB860;
    }

}
