package com.nuance.nmsp.client.sdk.oem.bluetooth;

import android.content.Context;
import android.media.AudioManager;
import android.media.MediaRecorder.AudioSource;

/**
 * Bluetooth functionality for Android 2.2.
 */
class Bluetooth_2_2 extends Bluetooth {
    private AudioManager mAudioManager;

    public Bluetooth_2_2(Context context) {
        super(context);
        mAudioManager = (AudioManager) mContext.getSystemService(Context.AUDIO_SERVICE);
    }

    @Override
    public int getPlaybackStream() {
        return isHeadsetConnected() ? Audio.AUDIO_TRACK_VOICE_CALL_STREAM : AudioManager.STREAM_MUSIC;
    }

    @Override
    public int getRecordingSource() {
        return isHeadsetConnected() ? Audio.AUDIO_RECORD_AUDIO_SOURCE : AudioSource.VOICE_RECOGNITION;
    }

    @Override
    public void startBluetoothScoInternal() {
        if (!AndroidVersion.USE_MUSIC_STREAM_FOR_BLUETOOTH) {
            mAudioManager.startBluetoothSco();
        }
    }

    @Override
    public void stopBluetoothSco() {
        if (!AndroidVersion.USE_MUSIC_STREAM_FOR_BLUETOOTH) {
            mAudioManager.stopBluetoothSco();
        }
    }
}
