/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.common.protocols;

public class ProtocolDefines {
    /** protocol defines **/
    public static final byte XMODE_PROTOCOL_VAP = 0x01;
    public static final byte XMODE_PROTOCOL_BCP = 0x02;
    public static final byte XMODE_PROTOCOL_COP = 0x03;
    public static final byte XMODE_PROTOCOL_BB_HANDSHAKE = 0x0f;
    
    /** protocol version defines **/
    public static final byte XMODE_VERSION_VAP = 0x12;
    public static final byte XMODE_VERSION_BCP = 0x23;
    public static final byte XMODE_VERSION_COP = 0x20;
    
    /** protocol commands defines **/
    public static final short XMODE_COP_COMMAND_CONNECT        = 0x0100;
    public static final short XMODE_COP_COMMAND_CONNECTED      = 0x0101;
    public static final short XMODE_COP_COMMAND_PING_REQUEST   = 0x0102;
    public static final short XMODE_COP_COMMAND_PING_RESPONSE  = 0x0103;
    public static final short XMODE_COP_COMMAND_CONFIRM        = 0x0106;
    public static final short XMODE_COP_COMMAND_DISCONNECT     = 0x0200;
    public static final short XMODE_COP_COMMAND_CONNECT_FAILED = 0x0300;
    
    public static final short XMODE_BCP_COMMAND_GENERATE_AUDIO            = 0x0A00;
    public static final short XMODE_BCP_COMMAND_LOAD_GRAMMAR              = 0x0A01;
    public static final short XMODE_BCP_COMMAND_RECOGNIZE                 = 0x0A02;
    public static final short XMODE_BCP_COMMAND_CANCEL                    = 0x0A03;
    public static final short XMODE_BCP_COMMAND_RESPONSE                  = 0x0A10;
    public static final short XMODE_BCP_COMMAND_GENERATE_AUDIO_COMPLETE   = 0x0A11;
    public static final short XMODE_BCP_COMMAND_START_OF_SPEECH           = 0x0A12;
    public static final short XMODE_BCP_COMMAND_RECOGNITION_COMPLETE      = 0x0A13;
    public static final short XMODE_BCP_COMMAND_RECOGNITION_INTERMRESULTS = 0x0A14;
    public static final short XMODE_BCP_COMMAND_SET_PARAMS                = 0x0A15;
    public static final short XMODE_BCP_COMMAND_SET_PARAMS_COMPLETE       = 0x0A16;
    public static final short XMODE_BCP_COMMAND_GET_PARAMS                = 0x0A17;
    public static final short XMODE_BCP_COMMAND_GET_PARAMS_COMPLETE       = 0x0A18;
    public static final short XMODE_BCP_COMMAND_BCP_DATA                  = 0x0A19;
    public static final short XMODE_BCP_COMMAND_CANCEL_RESPONSE           = 0x0A20;
    public static final short XMODE_BCP_COMMAND_BCP_BEGIN                 = 0x0A25;
    public static final short XMODE_BCP_COMMAND_BCP_END                   = 0x0A26;
    public static final short XMODE_BCP_COMMAND_LOAD_RESOURCE             = 0x0A27;
    public static final short XMODE_BCP_COMMAND_EVENT                     = 0x0A28;
    public static final short XMODE_BCP_COMMAND_FREE_RESOURCE             = 0x0A29;
    public static final short XMODE_BCP_COMMAND_FREE_RESOURCE_ID          = 0x0A30;
    public static final short XMODE_BCP_COMMAND_BCP_LOG                   = 0x0A50;
    public static final short XMODE_BCP_COMMAND_BCP_LOG_RESPONSE          = 0x0A51;
    public static final short XMODE_BCP_COMMAND_BCP_MDS_MESSAGE           = 0x0A60;
    public static final short XMODE_BCP_COMMAND_BCP_MDS_MESSAGE_RESPONSE  = 0x0A61;

    public static final short XMODE_VAP_COMMAND_RECORD_BEGIN = 0x0101;
    public static final short XMODE_VAP_COMMAND_RECORD_END   = 0x0100;
    public static final short XMODE_VAP_COMMAND_RECORD       = 0x0201;
    public static final short XMODE_VAP_COMMAND_PLAY_BEGIN   = 0x0210;
    public static final short XMODE_VAP_COMMAND_PLAY_END     = 0x0400;
    public static final short XMODE_VAP_COMMAND_PLAY         = 0x0200;
    
    /** size defines **/
    public static final byte XMODE_PACKET_HEADER_SIZE = 0x08;
    public static final byte BYTE_SIZE  = 0x01;
    public static final byte SHORT_SIZE = 0x02;
    public static final byte LONG_SIZE  = 0x04;
    public static final byte XMODE_XML_PAYLOAD_SIZE                         = LONG_SIZE;
    public static final byte XMODE_XML_PAYLOAD_TO_ROUTE_SIZE                = LONG_SIZE;
    public static final byte XMODE_SERVER_SESSION_UUID_SIZE                 = 16;
    public static final byte XMODE_CLIENT_COP_CONNECT_DATA_LEN_SIZE         = LONG_SIZE;
    public static final byte XMODE_CLIENT_COP_CONNECT_DATA_TYPE_SIZE        = BYTE_SIZE;
    public static final byte XMODE_SERVER_COP_CONNECTED_PAYLOAD_SIZE        = LONG_SIZE;
    public static final byte XMODE_SERVER_COP_CONNECT_FAILURE_CODE_SIZE     = SHORT_SIZE;
    public static final byte XMODE_SERVER_COP_CONNECT_FAILED_PAYLOAD_SIZE   = LONG_SIZE;
    public static final byte XMODE_CLIENT_COP_CONFIRM_DATA_LEN_SIZE         = LONG_SIZE;
    public static final byte XMODE_SERVER_COP_PING_REQUEST_ID_SIZE          = LONG_SIZE;
    public static final byte XMODE_CLIENT_COP_PING_RESPONSE_LATENCY_SIZE    = LONG_SIZE;
    public static final byte XMODE_CLIENT_COP_DISCONNECT_CODE_SIZE          = SHORT_SIZE;
    public static final byte XMODE_CLIENT_VAP_AUDIO_ID_SIZE                 = LONG_SIZE;
    public static final byte XMODE_CLIENT_VAP_AUDIO_LEN_SIZE                = LONG_SIZE;
    public static final byte XMODE_CLIENT_VAP_AUDIO_CODEC                   = SHORT_SIZE;
    public static final byte XMODE_CLIENT_ACCESS_TOKEN_VERSION_SIZE         = BYTE_SIZE;
    public static final byte XMODE_CLIENT_ACCESS_TOKEN_TYPE_SIZE            = BYTE_SIZE;
    public static final byte XMODE_CLIENT_ACCESS_TOKEN_DATA_SIZE            = LONG_SIZE;
    
    public static final byte XMODE_BCP_REQUEST_ID_SIZE                      = LONG_SIZE;
    public static final byte XMODE_BCP_TRANSACTION_ID_SIZE                  = BYTE_SIZE;
    public static final byte XMODE_SERVER_BCP_RESPONSE_STATUS_CODE_SIZE     = SHORT_SIZE;
    public static final byte XMODE_SERVER_BCP_RESPONSE_REQUEST_STATE_SIZE   = SHORT_SIZE;
    public static final byte XMODE_SERVER_BCP_COMPLETION_CAUSE_SIZE         = SHORT_SIZE;
    public static final byte XMODE_SERVER_BCP_RECOGNITION_COMPLETE_RES_LEN  = LONG_SIZE;
    public static final byte XMODE_SERVER_BCP_RECOGNITION_RESULT_TYPE       = BYTE_SIZE;
    public static final byte XMODE_SERVER_BCP_RECOGNITION_RESULT_LENGTH     = LONG_SIZE;
    public static final byte XMODE_BCP_GENERATE_AUDIO_AUDIO_ID_SIZE         = LONG_SIZE;
    public static final byte XMODE_BCP_SETPARAM_LENGTH_SIZE                 = LONG_SIZE;
    public static final byte XMODE_BCP_GETPARAM_LENGTH_SIZE                 = LONG_SIZE;
    public static final byte XMODE_SERVER_BCP_DATA_LENGTH                   = LONG_SIZE;
    public static final byte XMODE_SERVER_BCP_EVENT_CODE_SIZE               = SHORT_SIZE;
    public static final byte XMODE_SERVER_BCP_EVENT_PAYLOAD_LENGTH          = LONG_SIZE;
    public static final byte XMODE_SERVER_BCP_FREE_RESOURCE_TIMEOUT_LENGTH  = LONG_SIZE;
    public static final byte XMODE_PAYLOAD_LENGTH_SIZE                  	= LONG_SIZE;
    public static final byte XMODE_BCP_MDS_MESSAGE_INFO_SIZE                = LONG_SIZE;
    public static final byte XMODE_BCP_MDS_MESSAGE_SIZE                     = LONG_SIZE;

    /* BCP completion cause and status code */
    public static final short XMODE_BCP_RESPONSE_STATUS_OK              = 200;
    public static final short XMODE_BCP_RESPONSE_STATUS_METHOD_OPS_FAIL = 407;
    public static final short XMODE_BCP_RECOGNITION_COMPL_CAUSE_SUCCESS   = 0x0000;
    public static final short XMODE_BCP_RECOGNITION_COMPL_CAUSE_CANCELLED = 0x000B;
    public static final short XMODE_BCP_CANCEL_COMPL_CAUSE_SUCCESS = 0x0000;
    
    /* BCP Recognition Result Type */
    public static final byte XMODE_BCP_RECOGNITION_RESULT_TYPE_NSS = 0x0;
    public static final byte XMODE_BCP_RECOGNITION_RESULT_TYPE_APPSERVER = 0x1;
    
    /* NMSP XMODE PARAMS */
    public static final String XMODE_NMSP_PARAM_PING_INTERVAL_SECS          = "Ping_IntervalSecs";
    public static final String XMODE_NMSP_PARAM_PING_MIS_RESP_B4_DISCONNECT = "Ping_MissedResponsesBeforeDisconnect";
    public static final String XMODE_NMSP_PARAM_DSR_CODEC                   = "warp-factor";
    
    /* disconnect code defines */
    public static final short XMODE_DISCONNECT_CODE_NORMAL          = 0x0000;
    public static final short XMODE_DISCONNECT_CODE_TIMEOUT         = 0x0001;
    public static final short XMODE_DISCONNECT_CODE_SERVER_SHUTDOWN = 0x0002;
    public static final short XMODE_DISCONNECT_CODE_CRITICAL_ERROR  = 0x0003;
    public static final short XMODE_DISCONNECT_CODE_PING_TIME_OUT   = 0x0004;
    public static final short XMODE_DISCONNECT_CODE_SERVER_UNAVAILABLE = 0x0005;
    public static final short XMODE_DISCONNECT_CODE_ENDPOINT_EXCEPTION = 0x0006;
    public static final short XMODE_DISCONNECT_CODE_MAXAUDIO_PERSESSION= 0x0007;
    public static final short XMODE_DISCONNECT_CODE_MAXBYTE_PERAUDIO   = 0x0008;
    public static final short XMODE_DISCONNECT_CODE_UNKNOWN         = 0x0009;
    
    
    /** other defines **/
    public static final byte XMODE_PING_RESPONSE_ZERO_LATENCY = 0x0;
    public static final int XMODE_BUILD_DATE = 20091023;
    public static final byte XMODE_COP_CONNECT_DATA_TYPE_GATEWAY = 0x0;
    public static final byte XMODE_ACCESS_TOKEN_TYPE_JWT = 0x00;
    public static final byte XMODE_ACCESS_TOKEN_VERSION = 0x01;
    
    
    //#ifdef NMSP_PLATFORM_J2SE
//@    public static final short DEVICE_ID = 0x0006;
    //#else
    public static final short DEVICE_ID = 0x0007; //J2ME, Blackberry
    //#endif
}
