package com.nuance.nmsp.client2.sdk.components.core.calllog;

import com.nuance.nmsp.client2.sdk.components.core.calllog.CalllogSender.SenderListener;
import com.nuance.nmsp.client2.sdk.components.core.internal.calllog.CalllogSenderImpl;

/**
 * Factory class to create the {@link CalllogSender} object. The {@link SenderConfig}
 * contains the basic configuration including the network information and application
 * credentials for the call log server.
 * 
 * @see {@link CalllogSender}
 * @see {@link com.nuance.nmsp.client.sdk.components.resource.common.Manager}
 */
public class CalllogSenderFactory
{
    /**
     * Create the {@link CallogSender} with the given {@link SenderConfig} object.
     * 
     * @param config  The configuration for the {@link CallogSender}, must not be NULL
     * 
     * @return  The created CalllogSender object
     */
    public static CalllogSender createCalllogSender(SenderListener listener)
    {
        return new CalllogSenderImpl(listener); 
    }
}
