package com.nuance.nmsp.client2.sdk.components.core.internal.calllog;

import com.nuance.nmsp.client2.sdk.components.core.calllog.SessionEvent;
import com.nuance.nmsp.client2.sdk.components.core.pdx.Sequence;

public class RootSessionEventImpl extends SessionEventImpl
{
	private String _rootParentId = null;
	private int    _sequenceIdCounter = 1;

	private String _applicationName;
	private int    _retentionDays;
	protected SessionEvent  _appSessionEvent;
    
    RootSessionEventImpl(String rootParentId, String applicationName, String schemaVersion, int retentionDays, CalllogImpl calllog, String eventName)
    {
        super(eventName, schemaVersion, null, null, calllog);
        
        _applicationName = applicationName;
        _retentionDays = retentionDays;
        _appSessionEvent = null;
        	
        _rootParentId = rootParentId;
        _rootParent = this;
    }
    
    protected void genSeqId()
    {
        super.genSeqId();
    }
    
    protected Sequence buildMetaSeq() 
    {
        Sequence metaSeq = super.buildMetaSeq();
		
    	addEntryToSequence(metaSeq, NMSP_CALLLOG_META_APPLICATION_NAME, _applicationName);
    	addEntryToSequence(metaSeq, NMSP_CALLLOG_META_RETENTION_DAYS, new Integer(_retentionDays));
		return metaSeq;
	}

    public String getRootParentId()
    {
    	return _rootParentId;
    }
    
    public String getApplicationName()
    {
    	return _applicationName;
    }
    
    public String getSchemaVersion()
    {
    	return _schemaVersion;
    }

    public int getRetentionDays()
    {
    	return _retentionDays;
    }
    
    //-----------------------------------------------------
    // This function will be accessed from both SDK
    // internal message thread and the application
    // external thread, so make this function synchronized
    //-----------------------------------------------------
    public synchronized int getSequenceId()
    {
    	return _sequenceIdCounter++;
    }    
}
