/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.core.internal.pdx;


//#ifdef NMSP_LOG2
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory;
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory.Log;
//#endif

/**
 * PDX ASCII string representation
 * 
 */
public class PDXBoolean extends PDXClass {
    //#ifdef NMSP_LOG2
//@    private static final Log log = LogFactory.getLog(PDXAsciiString.class);
    //#endif

    private Boolean value;
    
    public PDXBoolean(Boolean value) {
        super(PDXClass.BOOLEAN);
        this.value = value;
        //#ifdef NMSP_LOG2
//@        log.debug("PDXBoolean() " + this.value);
        //#endif
    }

    public PDXBoolean(boolean value) {
        super(PDXClass.BOOLEAN);
        //#ifdef NMSP_LOG2
//@        log.debug("PDXBoolean() " + string);
        //#endif
        
        this.value = new Boolean(value);
    }
    
    public PDXBoolean(byte[] value){
    	super(PDXClass.BOOLEAN);
    	if(value == null){ 
    		this.value = false;
    	}
    	if(value.length < 1){
    		this.value = false;
    	}
    	this.value = value[0] != 0;
    }

    public boolean getValue() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXBoolean.getValue() " + this.value);
        //#endif
        return this.value.booleanValue();
    }

    public byte[] toByteArray() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXBoolean.toByteArray()");
        //#endif
    	//boolean booleanValue = value.booleanValue();
    	//String stringValue = Boolean.toString(booleanValue);
    	//byte[] byteValue = stringValue.getBytes();
    	//return super.toByteArray(byteValue);
    	byte[] retByte = new byte[1];
    	retByte[0] = (byte) (value ? 0xFF : 0x00);
    	return super.toByteArray(retByte);
    	
    }
}
