/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.core.internal.pdx;

//#ifdef NMSP_LOG
import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory;
import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory.Log;
//#endif

/**
 * PDX UTF8 string representation
 * 
 */
public class PDXUTF8String extends PDXClass {
    //#ifdef NMSP_LOG
    private static final Log log = LogFactory.getLog(PDXUTF8String.class);
    //#endif

    private String value;

    public PDXUTF8String(String string) {
        super(PDXClass.UTF8);
        //#ifdef NMSP_LOG2
//@        log.debug("PDXUTF8String() " + string);
        //#endif
        this.value = string;
    }

    public PDXUTF8String(byte[] string) {
        super(PDXClass.UTF8);
        try {
               this.value = new String(string, "UTF-8");
        } catch (Exception e) {
            //#ifdef NMSP_LOG
             log.error("PDXUTF8String() " + e.getMessage());
             //#endif
             this.value = new String(string);
          }
        //#ifdef NMSP_LOG2
//@        log.debug("PDXUTF8String() " + this.value);
        //#endif
    }

    public String getValue() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXUTF8String.getValue()");
        //#endif
        return this.value;
    }

    public byte[] toByteArray() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXUTF8String.getValue()");
        //#endif
        try {
            return super.toByteArray(this.value.getBytes("UTF-8"));
        } catch (Exception e) {
            //#ifdef NMSP_LOG
            log.error("PDXUTF8String().toByteArray() " + e.getMessage());
            //#endif
            return super.toByteArray(this.value.getBytes());
        }
    }
}
