/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.general;

 // for ovs
 // see com.nuance.nmsp.client.sdk.components.dictation.DictationTransaction#addAudio(byte[], int, int, boolean)
 // see com.nuance.nmsp.client.sdk.components.dictation.DictationTransaction#cancel()
/**
 * Thrown to indicate that a transaction is in the
 * FINISHED state, which is not appropriate for the
 * requested operation.
 * 
 * @see com.nuance.nmsp.client.sdk.components.resource.nmas.Command#sendParam(Parameter) sendParam()
 * @see com.nuance.nmsp.client.sdk.components.resource.nmas.Command#end() end()
 * 
 **/
public class TransactionAlreadyFinishedException extends Exception {
    private static final long serialVersionUID = 8972089019546729219L;

    public TransactionAlreadyFinishedException(String message) {
        super(message);
    }
}
