/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.resource.internal.nmas;

//#ifdef NMSP_LOG2
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory;
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory.Log;
//#endif
import com.nuance.nmsp.client2.sdk.components.resource.nmas.Parameter;

public class PDXDataParam extends PDXParam implements Parameter {
    //#ifdef NMSP_LOG2
//@    private static final Log log = LogFactory.getLog(PDXDataParam.class);
    //#endif

    private byte[] paramData;

    public PDXDataParam(String name, byte[] data) {
        super(name, PDXParam.DATA_PARAMETER);
        //#ifdef NMSP_LOG2
//@        log.debug("PDXDataParam() name: " + name + " data: " + data);
        //#endif
        this.paramData = new byte[data.length];
        System.arraycopy(data, 0, this.paramData, 0, this.paramData.length);
    }

    protected byte[] getData() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXDataParam.getData()");
        //#endif
        return this.paramData;
    }
}
