/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.resource.internal.nmas;

//#ifdef NMSP_LOG2
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory;
//@import com.nuance.nmsp.client.sdk.common.oem.api.LogFactory.Log;
//#endif

public class PDXParam {
    //#ifdef NMSP_LOG2
//@    private static final Log log = LogFactory.getLog(PDXParam.class);
    //#endif

    private String name;
    private byte type;

    protected static final byte AUDIO_PARAMETER = 0x01;
    protected static final byte TEXT_PARAMETER = 0x02;
    protected static final byte CHOICE_PARAMETER = 0x03;
    protected static final byte DATA_PARAMETER = 0x04;
    protected static final byte DICT_PARAMETER = 0x05;
    protected static final byte SEQ_PARAMETER_START = 0x06;
    protected static final byte SEQ_PARAMETER_CHUNK = 0x07;
    protected static final byte SEQ_PARAMETER_END = 0x08;
    protected static final byte TTS_PARAMETER = 0x7F; // internal use only, not part of the PDX protocol

    public PDXParam(String name, byte type) {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXParam() name: " + name + " type: " + type);
        //#endif
        this.name = name;
        this.type = type;
    }

    public PDXParam(String name) {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXParam() name: " + name);
        //#endif
        this.name = name;
    }

    public String getName() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXParam.getName()");
        //#endif
        return this.name;
    }

    public byte getType() {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXParam.getType()");
        //#endif
        return this.type;
    }

    public void setType(byte type) {
        //#ifdef NMSP_LOG2
//@        log.debug("PDXParam.setType()");
        //#endif
        this.type = type;
    }
}
