/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.resource.internal.nmas;

//#ifdef NMSP_LOG
import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory;
import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory.Log;
//#endif
import com.nuance.nmsp.client2.sdk.components.resource.nmas.QueryError;

//<DICT>
//<ASCII>description</ASCII><UTF8>(diagnostic description)</UTF8>
//<ASCII>error</ASCII><INT>(error code enum)</INT>
//
//(Optional - depending on if error was related to a specific parameter )
//<ASCII>parameter</ASCII><UTF8>(name of parameter)</UTF8>
//</DICT>

public class PDXQueryError extends PDXMessage implements QueryError {
    //#ifdef NMSP_LOG
    private static final Log log = LogFactory.getLog(PDXQueryError.class);
    //#endif

    // protected static final short PDXERR_NO_RESULTS = 100;
    // protected static final short PDXERR_CANNOT_RECOGNIZE_PARAMETER = 300;
    // protected static final short PDXERR_INVALID_PARAMETER_TYPE = 310;
    // protected static final short PDXERR_UNKNOWN_ERROR_CONSTRUCTING_RESULTS =
    // 400;
    // protected static final short PDXERR_IO_ERROR_RETRIEVING_RESULTS = 500;

    public PDXQueryError(byte[] input) {
        super(PDXMessage.QueryError, input);
        //#ifdef NMSP_LOG3
//@        String inputHex = "";
//@        for(int i = 0; i < input.length; i++) {
//@            inputHex += Integer.toString( ( input[i] & 0xff ) + 0x100, 16).substring( 1 );
//@        }
//@        log.debug("PDXQueryError() " + inputHex);
        //#endif
    }

    public int getError() {
        //#ifdef NMSP_LOG
        log.debug("PDXQueryError.getError()");
        //#endif
        return getInteger("error");
    }

    public String getDescription() {
        //#ifdef NMSP_LOG
        log.debug("PDXQueryError.getDescription()");
        //#endif
        String description = getUTF8String("description");
        if (description != null) {
            return description;
        } else {
            return "";
        }
    }
}
