/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.components.resource.internal.nmas;

//#ifdef NMSP_LOG
import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory;
import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory.Log;
//#endif
import com.nuance.nmsp.client2.sdk.components.resource.nmas.QueryRetry;

//<DICT>
//<ASCII>name</ASCII><UTF8>(Name of the parameter)</UTF8>
//</DICT>

public class PDXQueryRetry extends PDXMessage implements QueryRetry {
    //#ifdef NMSP_LOG
    private static final Log log = LogFactory.getLog(PDXQueryRetry.class);
    //#endif

    public PDXQueryRetry(byte[] input) {
        super(PDXMessage.QueryRetry, input);
        //#ifdef NMSP_LOG3
//@        String inputHex = "";
//@        for(int i = 0; i < input.length; i++) {
//@            inputHex += Integer.toString( ( input[i] & 0xff ) + 0x100, 16).substring( 1 );
//@        }
//@        log.debug("PDXQueryRetry() " + inputHex);
        //#endif
    }

    public String getName() {
        //#ifdef NMSP_LOG
        log.debug("PDXQueryRetry.getName()");
        //#endif
        String name = getUTF8String("name");
        if (name != null) {
            return name;
        } else {
            return "";
        }
    }

    public int getCause() {
        //#ifdef NMSP_LOG
        log.debug("PDXQueryRetry.getCause()");
        //#endif
        int cause;
        try {
            cause = getInteger("cause");
        } catch(Exception e) {
            cause = 0;
        }
        
        return cause;
    }

    public String getPrompt() {
        //#ifdef NMSP_LOG
        log.debug("PDXQueryRetry.getPrompt()");
        //#endif
        String prompt;
        try {
            prompt = getUTF8String("prompt");
        } catch (Exception e) {
            prompt = "";
        }
        
        if (prompt != null) {
            return prompt;
        } else {
            return "";
        }
    }
}
