/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.oem;

import com.nuance.nmsp.client2.sdk.common.oem.api.LogFactory.Log;

public class LogOEM extends Log {
    private static final String TAG = "NMSP";
    private static final String TAG_ALL_ON = "NMSP_";
    
    String className;
    
    public LogOEM(Class klass) {
        className = klass.getSimpleName();
    }

    public void setCurrentSession(String uuid) {
    }
    
    public void unsetCurrentSession() {
    }

    public void debug(Object message) {
        android.util.Log.d(TAG_ALL_ON, "[" + className + "] " + message.toString());
    }

    public void debug(Object message, Throwable t) {
        t.printStackTrace();
        android.util.Log.d(TAG_ALL_ON, "[" + className + "] " + message.toString(), t);
    }

    public void error(Object message) {
        android.util.Log.e(TAG, "[" + className + "] " + message.toString());
    }

    public void error(Object message, Throwable t) {
        t.printStackTrace();
        android.util.Log.e(TAG, "[" + className + "] " + message.toString(), t);
    }

    public void fatal(Object message) {
        android.util.Log.e(TAG, "[" + className + "] " + message.toString());
    }

    public void fatal(Object message, Throwable t) {
        t.printStackTrace();
        android.util.Log.e(TAG, "[" + className + "] " + message.toString(), t);
    }

    public void info(Object message) {
        android.util.Log.i(TAG, "[" + className + "] " + message.toString());
    }

    public void info(Object message, Throwable t) {
        t.printStackTrace();
        android.util.Log.i(TAG, "[" + className + "] " + message.toString(), t);
    }
    
    public void trace(Object message) {
        android.util.Log.v(TAG_ALL_ON, "[" + className + "] " + message.toString());
    }

    public void trace(Object message, Throwable t) {
        t.printStackTrace();
        android.util.Log.v(TAG_ALL_ON, "[" + className + "] " + message.toString(), t);
    }

    public void warn(Object message) {
        android.util.Log.w(TAG, "[" + className + "] " + message.toString());
   }

    public void warn(Object message, Throwable t) {
        t.printStackTrace();
        android.util.Log.w(TAG, "[" + className + "] " + message.toString(), t);
    }

    public boolean isDebugEnabled() {
    	//#ifdef NMSP_LOG
    	return android.util.Log.isLoggable(TAG_ALL_ON, android.util.Log.DEBUG);
    	//#else
//@        return false;
        //#endif
    }

    public boolean isErrorEnabled() {
    	//#ifdef NMSP_LOG
    	return android.util.Log.isLoggable(TAG, android.util.Log.ERROR);
    	//#else
//@        return false;
        //#endif
    }

    public boolean isFatalEnabled() {
        //#ifdef NMSP_LOG
     return android.util.Log.isLoggable(TAG, android.util.Log.ERROR);
        //#else
//@    	return true;
        //#endif
    }

    public boolean isInfoEnabled() {
    	//#ifdef NMSP_LOG
    	return android.util.Log.isLoggable(TAG, android.util.Log.INFO);
    	//#else
//@        return false;
        //#endif
    }

    public boolean isTraceEnabled() {
    	//#ifdef NMSP_LOG
    	return android.util.Log.isLoggable(TAG_ALL_ON, android.util.Log.VERBOSE);
    	//#else
//@        return false;
        //#endif
    }

    public boolean isWarnEnabled() {
    	//#ifdef NMSP_LOG
    	return android.util.Log.isLoggable(TAG, android.util.Log.WARN);
    	//#else
//@        return false;
        //#endif
    }
}
