/**
 *  Copyright 2006-2011, Nuance Communications Inc. All rights reserved.
 *
 *  Nuance Communications, Inc. provides this document without representation
 *  or warranty of any kind. The information in this document is subject to
 *  change without notice and does not represent a commitment by Nuance
 *  Communications, Inc. The software and/or databases described in this
 *  document are furnished under a license agreement and may be used or
 *  copied only in accordance with the terms of such license agreement.
 *  Without limiting the rights under copyright reserved herein, and except
 *  as permitted by such license agreement, no part of this document may be
 *  reproduced or transmitted in any form or by any means, including, without
 *  limitation, electronic, mechanical, photocopying, recording, or otherwise,
 *  or transferred to information storage and retrieval systems, without the
 *  prior written permission of Nuance Communications, Inc.
 *
 *  Nuance, the Nuance logo, Nuance Recognizer, and Nuance Vocalizer are
 *  trademarks or registered trademarks of Nuance Communications, Inc. or its
 *  affiliates in the United States and/or other countries. All other
 *  trademarks referenced herein are the property of their respective owners.
 **/

package com.nuance.nmsp.client2.sdk.oem;

import java.util.UUID;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import com.nuance.nmsp.client2.sdk.common.oem.api.MiscSystem;

public class MiscSystemOEM extends MiscSystem {

	protected byte[] HMAC_SHA1_impl(byte[] key, byte[] data) {
		return HMAC_SHA1_impl(key, data, 0);
	}
	
	protected byte[] HMAC_SHA1_impl(byte[] key, byte[] data, int offset) {
		if(key == null || data == null)
			return new byte[0];
		
		try {
        	SecretKeySpec hmacKey = new SecretKeySpec(key, "HmacSHA1");
            
            Mac mac = Mac.getInstance("HmacSHA1");
            mac.init(hmacKey);
            mac.update(data, offset, data.length - offset);
            byte[] hData = mac.doFinal();
        	
			return hData;
		} catch (Exception e) {
			return new byte[0];
		}
	}

    protected String newUUID_impl()
    {
        return UUID.randomUUID().toString();
    }

}
