package com.nuance.nmsp.client2.sdk.oem.bluetooth;

import android.content.Context;
import android.media.AudioManager;
import android.media.MediaRecorder.AudioSource;

/**
 * Bluetooth functionality for Android >= 2.3
 */
class BluetoothImpl_2_3 extends Bluetooth {
    private AudioManager mAudioManager;
    
    public BluetoothImpl_2_3(Context context) {
        super(context);
        mAudioManager = (AudioManager) mContext.getSystemService(Context.AUDIO_SERVICE);
    }

    @Override
    public int getPlaybackStream() {
        return isHeadsetConnected() ? Audio.AUDIO_TRACK_VOICE_CALL_STREAM : AudioManager.STREAM_MUSIC;
    }

    @Override
    public int getRecordingSource() {
        return isHeadsetConnected() ? Audio.AUDIO_RECORD_AUDIO_SOURCE : AudioSource.VOICE_RECOGNITION;
    }

    @Override
    public void startBluetoothScoInternal() {
        mAudioManager.startBluetoothSco();
    }

    @Override
    public void stopBluetoothSco() {
        mAudioManager.stopBluetoothSco();
    }
}
