package com.xyz.sdk.http;

import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Set;

/**
 * Created by zhangzheng on 2016/2/18.
 */
public class HttpParams {

    HashMap<String,String> params=new HashMap<>();
    

    public HashMap<String, String> getMapParams() {
		return params;
	}

	public void put(String key,String value){
        params.put(key,value);
    }

    public boolean has(String key){
        return params.containsKey(key);
    }

    public String getStringVlaue(String key){
        return params.get(key);
    }

    public void add(String key,String value){
        if(has(key)){
            put(key,getStringVlaue(key)+"&"+value);
        }else{
            put(key,value);
        }
    }

    @Override
    public String toString() {
        Set<String> keys = params.keySet();
        StringBuilder params=new StringBuilder();
        for (String key:keys){
            String value=getStringVlaue(key);
            params.append(decodeParam(key,value));
        }
        return params.deleteCharAt(params.length()-1).toString();
    }

    private String decodeParam(String key,String value){
        if(value==null||value.trim().equals("")){
            return "";
        }
        StringBuilder param=new StringBuilder();
        if(!value.contains("&")){
            param.append(key+"="+ URLEncoder.encode(value)+"&");
        }else{
            String[] values = value.split("&");
            for (String v:values){
                param.append(key+"="+URLEncoder.encode(v)).append("&");
            }
        }
        return param.toString();
    }
}
