package com.xyz.sdk.http;

import com.xyz.sdk.XYZSDKManager;
import com.xyz.sdk.http.util.Utils;
import com.xyz.sdk.utils.XYZSdkUtils;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by zhangzheng on 2016/2/18.
 */
public abstract class HttpRequest extends XYZUrl{

    HttpParams params;
    @Override
    public HttpParams getParams() {
        if(params==null) {
            params = new HttpParams();
            buildRequestParams(params);
//            encodeRequestParams(params);
        }
        return params;
    }

    protected abstract void buildRequestParams(HttpParams params);

    public static class Code
    {
        public static final String v = "1.0.2";
        public static final String uid = "14749";
        public static final String sid = "API_APP_AND";
        public static final String appsecret = "abcd1233";
    }

    public static void encodeRequestParams(HttpParams params) {
        //添加版本号
        String v = Code.v;
        params.put("v", v);
        params.put("deviceId", XYZSdkUtils.getOnlyDeviceId(XYZSDKManager.getContext()));
        //添加用户ID
        String uid = Code.uid;
        params.put("uid", uid);
        //添加渠道ID
        String sid = Code.sid;
        params.put("sid", sid);
        //添加时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String ts = sdf.format(new Date());
        params.put("ts", ts);
        //添加加密信息
        StringBuilder sig = new StringBuilder();
        sig.append(uid).append(",");
        sig.append(sid).append(",");
        sig.append(ts).append(",");

        if (params.has("loginId")) {
            sig.append(params.getStringVlaue("loginId")).append(",");
        }
        if (params.has("orderId")) {
            sig.append(params.getStringVlaue("orderId")).append(",");
        }
        if (params.has("policyId")) {
            sig.append(params.getStringVlaue("policyId")).append(",");
        }
        if (params.has("applicationId")) {
            sig.append(params.getStringVlaue("applicationId")).append(",");
        }
        sig.append(Utils.md5(Code.appsecret));
        params.put("sig", Utils.md5(sig.toString()));
    }
}
