package com.xyz.sdk.http.manager;

import android.util.Log;

import com.xyz.sdk.http.XYZUrl;
import com.xyz.sdk.http.interfaces.IHttpManager;
import com.xyz.sdk.http.manager.asynchHttp.AsyncHttpClientManager;
import com.xyz.sdk.http.util.StreamTool;

import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

/**
 * 网络请求工具类
 * Created by zhangzheng on 2016/2/18.
 */
public class HttpRequestManager {

    public enum RequestModel{
        GET,POST
    }
    
    private static IHttpManager httpManager=new AsyncHttpClientManager();
    
    public static void setHttpManager(IHttpManager httpManager) {
		HttpRequestManager.httpManager = httpManager;
	}

	public static String request(XYZUrl xyzUrl,RequestModel model){
		String requestResult="";
        try {
        	if(httpManager!=null&&httpManager.isTakeOver()){
        		return httpManager.takeOverRequest(xyzUrl, model);
        	}
            String api=xyzUrl.getApi();
            if(model==RequestModel.GET){
                api=api+"?"+xyzUrl.getParams().toString();
            }
            Log.i("request",api);
            URL url = new URL(api);

            HttpURLConnection conn;

            if (url.getProtocol().toLowerCase().equals("https")) {
                trustAllHosts();
                conn = (HttpsURLConnection) url.openConnection();
                ((HttpsURLConnection) conn).setHostnameVerifier(DO_NOT_VERIFY);// 不进行主机名确认
            }else{
                conn = (HttpURLConnection) url.openConnection();
            }

            conn.setConnectTimeout(10*1000);
            if(model==RequestModel.POST){
                conn.setDoOutput(true);
                conn.setRequestMethod("POST");
                conn.getOutputStream().write(xyzUrl.getParams().toString().getBytes());
            }else{
                conn.setRequestMethod("GET");
            }
            InputStream inputStream = conn.getInputStream();
            byte[] result = StreamTool.readInputStream(inputStream);
            requestResult=new String(result);
        }  catch (Exception e) {
            e.printStackTrace();
        }
        return requestResult;
    }



    static class MytmArray implements X509TrustManager {
        public X509Certificate[] getAcceptedIssuers() {
            // return null;
            return new X509Certificate[] {};
        }

        @Override
        public void checkClientTrusted(X509Certificate[] chain, String authType)
                throws CertificateException {
            // TODO Auto-generated method stub

        }

        @Override
        public void checkServerTrusted(X509Certificate[] chain, String authType)
                throws CertificateException {
            // TODO Auto-generated method stub
            // System.out.println("cert: " + chain[0].toString() + ", authType: "
            // + authType);
        }
    };

    static TrustManager[] xtmArray = new MytmArray[] { new MytmArray() };
    private static void trustAllHosts() {
        // Create a trust manager that does not validate certificate chains
        // Android 采用X509的证书信息机制
        // Install the all-trusting trust manager
        try {
            SSLContext sc = SSLContext.getInstance("TLS");
            sc.init(null, xtmArray, new java.security.SecureRandom());
            HttpsURLConnection
                    .setDefaultSSLSocketFactory(sc.getSocketFactory());
            // HttpsURLConnection.setDefaultHostnameVerifier(DO_NOT_VERIFY);//
            // 不进行主机名确认
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static HostnameVerifier DO_NOT_VERIFY = new HostnameVerifier() {
        @Override
        public boolean verify(String hostname, SSLSession session) {
            // TODO Auto-generated method stub
            // System.out.println("Warning: URL Host: " + hostname + " vs. "
            // + session.getPeerHost());
            return true;
        }
    };


}
