package com.xyz.sdk.http.manager.asynchHttp;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Set;

import org.apache.http.Header;
import org.apache.http.impl.client.DefaultHttpClient;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.AsyncHttpResponseHandler;
import com.loopj.android.http.RequestParams;
import com.xyz.sdk.http.XYZUrl;
import com.xyz.sdk.http.interfaces.IHttpManager;
import com.xyz.sdk.http.manager.HttpRequestManager.RequestModel;

public class AsyncHttpClientManager implements IHttpManager {

	Object lock = new Object();
	String result = "";
	private static boolean isTakeOver = true;
	private Object responseHandler;

	static {
		try {
			Class.forName("com.loopj.android.http.AsyncHttpClient");
			isTakeOver = true;
		} catch (ClassNotFoundException e) {
			isTakeOver = false;
		}
	}

	public AsyncHttpClientManager() {
		if (!isTakeOver) {
			return;
		}
		responseHandler = new AsyncHttpResponseHandler() {
			@Override
			public void onSuccess(int statusCode, Header[] headers,
					byte[] responseBody) {
				result = new String(responseBody);
				synchronized (lock) {
					lock.notifyAll();
				}
			}

			@Override
			public void onFailure(int statusCode, Header[] headers,
					byte[] responseBody, Throwable error) {
				synchronized (lock) {
					lock.notifyAll();
				}
			}

		};
	}

	@Override
	public boolean isTakeOver() {
		return isTakeOver;
	}

	@Override
	public String takeOverRequest(XYZUrl xyzUrl, RequestModel model) {

		lock = new Object();
		AsyncHttpClient client = new AsyncHttpClient();

		if (xyzUrl.getApi().contains("https")) {
			try {
				DefaultHttpClient httpClient = HttpClientHelper.getHttpClient();
				Field httpClientField = client.getClass().getDeclaredField(
						"httpClient");
				httpClientField.setAccessible(true);
				httpClientField.set(client, httpClient);
			} catch (NoSuchFieldException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			}
		}

		if (model == RequestModel.GET) {
			client.get(xyzUrl.getApi() + "?" + xyzUrl.getParams().toString(),
					(AsyncHttpResponseHandler) responseHandler);
		} else {
			HashMap<String, String> mapParams = xyzUrl.getParams()
					.getMapParams();
			Set<String> keySet = mapParams.keySet();
			RequestParams requestParams = new AsyncHttpParam();
			for (String key : keySet) {
				String value = mapParams.get(key);
				if (value.contains("&")) {
					String[] split = value.split("&");
					for (String v : split) {
						requestParams.add(value, v);
					}
				} else {
					requestParams.put(key, value);
				}
			}

			client.post(xyzUrl.getApi(), requestParams,
					(AsyncHttpResponseHandler) responseHandler);

		}
		synchronized (lock) {
			try {
				lock.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

		return result;
	}

}
