package com.xyz.sdk.http.manager.asynchHttp;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.Serializable;
import java.util.LinkedHashSet;
import java.util.List;

import org.apache.http.message.BasicNameValuePair;

import com.loopj.android.http.RequestParams;

public class AsyncHttpParam extends RequestParams implements Serializable
{
	private static final long serialVersionUID = 1L;

	/**
	 * 构造索引字符串
	 * 
	 * @param position
	 * @return
	 */
	protected String formatPosition(int position)
	{
		return "[" + position + "]";
	}
	

	public String getStringVlaue(String key) {
		List<BasicNameValuePair> params =  super.getParamsList();
		for (int i = 0; i < params.size(); i++) {
			BasicNameValuePair pair = params.get(i);
			if (pair.getName().equals(key)) {
				return pair.getValue();
			}
		}
		return null;
	}

	@Override
	public void put(String key, String value) {
		super.put(key, value);
	}

	@Override
	public void put(String key, File[] files) throws FileNotFoundException {
		super.put(key, files);
	}

	@Override
	public void put(String key, File[] files, String contentType, String customFileName) throws FileNotFoundException {
		super.put(key, files, contentType, customFileName);
	}

	@Override
	public void put(String key, File file) throws FileNotFoundException {
		super.put(key, file);
	}

	@Override
	public void put(String key, String customFileName, File file) throws FileNotFoundException {
		super.put(key, customFileName, file);
	}

	@Override
	public void put(String key, File file, String contentType) throws FileNotFoundException {
		super.put(key, file, contentType);
	}

	@Override
	public void put(String key, File file, String contentType, String customFileName) throws FileNotFoundException {
		super.put(key, file, contentType, customFileName);
	}

	@Override
	public void put(String key, InputStream stream) {
		super.put(key, stream);
	}

	@Override
	public void put(String key, InputStream stream, String name) {
		super.put(key, stream, name);
	}

	@Override
	public void put(String key, InputStream stream, String name, String contentType) {
		super.put(key, stream, name, contentType);
	}

	@Override
	public void put(String key, InputStream stream, String name, String contentType, boolean autoClose) {
		super.put(key, stream, name, contentType, autoClose);
	}

	@Override
	public void put(String key, Object value) {
		super.put(key, value);
	}

	@Override
	public void put(String key, int value) {
		super.put(key, value);
	}

	@Override
	public void put(String key, long value) {
		super.put(key, value);
	}

	@Override
	public void add(String key, String value) {
		if (key != null && value != null) {
			Object params = urlParamsWithObjects.get(key);
			if(params==null){
				params = new LinkedHashSet<>();
				this.put(key, params);
			}
			super.add(key, value);
		}
	}
}
