package com.xyz.sdk.http.model.request;

import com.xyz.sdk.general.API;
import com.xyz.sdk.http.HttpParams;
import com.xyz.sdk.http.HttpRequest;

import java.util.ArrayList;

/**
 * Created by zhangzheng on 2016/2/23.
 */
public class PlanGetReq extends HttpRequest {

    private static final long serialVersionUID = 1L;
    private String planId;
    private ArrayList<String> fields;

    public PlanGetReq()
    {
        fields = new ArrayList<String>();
    }

    public void setPlanId(String planId)
    {
        this.planId = planId;
    }

    public void addFields(String field)
    {
        fields.add(field);
    }

    @Override
    protected void buildRequestParams(HttpParams params) {
        params.put("planId", planId);
        for(String field : fields)
        {
            params.add("fields", field);
        }
    }

    @Override
    public String getApi() {
        return API.API_PRODUCT_PLAN_GET;
    }
}
