package com.xyz.sdk.http.model.request;

import com.xyz.sdk.general.API;
import com.xyz.sdk.http.HttpParams;
import com.xyz.sdk.http.HttpRequest;
import com.xyz.sdk.utils.StringUtils;

public class PlanTrialReq extends HttpRequest {
	private static final long serialVersionUID = 1L;
	private String planId;
	private String gender;
	private String periodStart;
	private String periodEnd;
	private String birthday;

	public void setPlanId(String planId) {
		this.planId = planId;
	}

	public void setGender(String gender) {
		this.gender = gender;
	}

	public void setPeriodStart(String periodStart) {
		this.periodStart = periodStart;
	}

	public void setPeriodEnd(String periodEnd) {
		this.periodEnd = periodEnd;
	}

	public void setBirthday(String birthday) {
		this.birthday = birthday;
	}

	@Override
	public String getApi() {
		return API.API_PRODUCT_PLAN_TRIAL;
	}

	@Override
	protected void buildRequestParams(HttpParams params) {
		params.put("planId", planId);
		params.put("gender", gender);
		params.put("birthday", birthday);
		params.add("period", periodStart);
		params.add("period", periodEnd);
	}

	public boolean isFull() {
		return !StringUtils.isNull(planId) && !StringUtils.isNull(gender)
				&& !StringUtils.isNull(birthday) && !StringUtils.isNull(periodStart)
				&& !StringUtils.isNull(periodEnd);
	}

	@Override
	public String toString() {
		return planId + gender + birthday + periodStart + periodEnd;
	}
}