package com.xyz.sdk.json.bean;

import java.util.HashMap;
import java.util.List;

/**
 * Created by zhangzheng on 2016/2/22.
 * 基础类型bean
 */
public class JsonParseBean {

    private HashMap<String, Object> baseParams = new HashMap<>();

    public HashMap<String, Object> getBaseParams() {
        return baseParams;
    }

    public void setBaseParams(HashMap<String, Object> baseParams) {
        this.baseParams = baseParams;
    }

    public void putInt(String key, int value) {
        baseParams.put(key+"-"+1,value);
    }

    public void putBoolean(String key, boolean value) {
        baseParams.put(key+"-"+2,value);

    }

    public void putString(String key, String value) {
        baseParams.put(key+"-"+3,value);
    }

    public void putObject(String key, JsonParseBean value) {
        baseParams.put(key+"-"+4,value);
    }

    public void putArray(String key, List value){
        if(value.size()==0){
            return;
        }
        Object object = value.get(0);
        if(object instanceof Integer){
            putIntArray(key,value);
        }else if(object instanceof String){
            putStringArray(key,value);
        }else if(object instanceof Boolean){
            putBooleanArray(key,value);
        }else if(object instanceof JsonParseBean){
            putObjectArray(key,value);
        }
    }

    public void putIntArray(String key, List<Integer> values) {
        baseParams.put(key+"-"+5,values);
    }

    public void putBooleanArray(String key, List<Boolean> values) {
        baseParams.put(key+"-"+6,values);
    }

    public void putStringArray(String key, List<String> values) {
        baseParams.put(key+"-"+7,values);
    }

    public void putObjectArray(String key, List<JsonParseBean> values) {
        baseParams.put(key+"-"+8,values);
    }

}
