package com.xyz.sdk.json.manager;

import com.xyz.sdk.json.interfaces.IJsonParse;

import java.lang.reflect.Method;

/**
 * Created by zhangzheng on 2016/2/23.
 */
public class JsonManager {

    private JsonManager(){}

    private static JsonManager jsonManager=new JsonManager();

    public static JsonManager getInstence(){
        return jsonManager;
    }

    private IJsonParse jsonParse;

    public void setJsonParse(IJsonParse jsonParse) {
        this.jsonParse = jsonParse;
    }
    public IJsonParse getJsonParse(){
        if(jsonParse!=null){
            return jsonParse;
        }
        IJsonParse fastJsonJsonParse = getFastJsonJsonParse();
        if(fastJsonJsonParse!=null){
            jsonParse= fastJsonJsonParse;
            return jsonParse;
        }
        return null;
    }

    private IJsonParse getFastJsonJsonParse(){
        try {
            Class<?> jsonClass = Class.forName("com.alibaba.fastjson.JSON");
            final Method parseObject = jsonClass.getMethod("parseObject", String.class, Class.class);
            if(parseObject==null){
                return null;
            }
            return new IJsonParse() {
                @Override
                public <T> T parseJson(String json, Class<T> cla) throws Exception{
                    return (T) parseObject.invoke(null,json,cla);
                }
            };
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        }
        return null;
    }
}
