package com.xyz.sdk.product.bean;

import com.xyz.sdk.product.bean.plan.ActiveTimeUnit;
import com.xyz.sdk.product.bean.plan.Benefits;
import com.xyz.sdk.product.bean.plan.City;
import com.xyz.sdk.product.bean.plan.Clauses;
import com.xyz.sdk.product.bean.plan.HomeType;
import com.xyz.sdk.product.bean.plan.KeyValues;
import com.xyz.sdk.product.bean.plan.ProdPromotionTag;
import com.xyz.sdk.product.bean.plan.Province;
import com.xyz.sdk.product.bean.plan.UnderwAge;
import com.xyz.sdk.product.bean.plan.UnderwGender;
import com.xyz.sdk.product.manager.AreaManager;
import com.xyz.sdk.utils.StringUtils;
import com.xyz.sdk.utils.XYZSdkUtils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by zhangzheng on 2016/2/23.
 */
public class Plan implements Serializable
{

    public static class Bank implements Serializable{
        private String id;
        private String name="";
        private String code;
        private String parentId;
        private String sort;
        private String status;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public void setCode(String code) {
            this.code = code;
        }

        public String getParentId() {
            return parentId;
        }

        public void setParentId(String parentId) {
            this.parentId = parentId;
        }

        public String getSort() {
            return sort;
        }

        public void setSort(String sort) {
            this.sort = sort;
        }

        public String getStatus() {
            return status;
        }

        public void setStatus(String status) {
            this.status = status;
        }

    }

    private static final long serialVersionUID = 1L;
    private String planId;
    private String planIdEn;
    private String name;
    private String shortName;
    private String type;
    private String kind;
    private String sort;
    private String insComId;
    private String insComName;
    private String insComImgUrl;
    private String forTheCrowd;
    private String maxLimitCopies;
    private ArrayList<String> policyTypes;
    private String marketPrice;
    private String discountPrice;
    private String tailType;
    private String status;
    private String imgUrl;
    private String largeUrl;
    private String bigImgUrl;
    private String outPolicyTime;
    private String outPolicyTimeUnit;
    private String fastestActiveTime;
    private ActiveTimeUnit fastestActiveTimeUnit;
    private String planFeatures;
    private String planReading;
    private String underwExamples;
    private String claimsExamples;
    private String noticeToUnderw;
    private ArrayList<String> categories;
    private ArrayList<String> scategories;
    private ArrayList<String> tags;
    private ArrayList<Clauses> clauses;
    private UnderwGender underwGender;
    private UnderwAge underwAge;
    private ArrayList<Province> underwAreas;
    private KeyValues protectionPeriod;
    private ArrayList<String> tourDestinations;
    private String occupationalLevel;
    private ArrayList<String> relationshipToPolicyholders;
    private ArrayList<Benefits> benefits;
    private boolean notUnderwAreaFlag;
    private boolean notUnderwVehiclesFlag;
    private boolean insuredEnNameFlag;
    private String maxActiveTime;
    private ActiveTimeUnit maxActiveUnit;
    private String lastModified;
    private boolean flightNoFlag;
    private ArrayList<ProdPromotionTag> promotions;
    private boolean needHomeTypeFlag;
    private ArrayList<HomeType> homeType;
    private boolean needHomeProCityFlag;
    private ArrayList<String> homeProvince;
    private boolean needZipCodeFlag;
    private boolean needHomeAddressFlag;
    private int limitPeopleNum = 0;

    /**华夏常青树专用字段，用于保费试算*/
    private String prodCode;

    /**热门银行*/
    private List<Bank>  hotBanks;

    /**普通银行*/
    private List<Bank> normalBanks;

    public String getProdCode() {
        return prodCode;
    }

    public void setProdCode(String prodCode) {
        this.prodCode = prodCode;
    }

    public List<Bank> getHotBanks() {
        return hotBanks;
    }

    public void setHotBanks(List<Bank> hotBanks) {
        this.hotBanks = hotBanks;
    }

    public List<Bank> getNormalBanks() {
        return normalBanks;
    }

    public void setNormalBanks(List<Bank> normalBanks) {
        this.normalBanks = normalBanks;
    }

    //销量
    private String buyNum;
    public String getBuyNum() {
        return buyNum==null?"0":buyNum;
    }
    public void setBuyNum(String buyNum) {
        this.buyNum = buyNum;
    }

    public boolean isOverseasInsurance()
    {
        if (categories == null) {
            return false;
        }
        return categories.contains("10-101");
    }

    public String getPlanId()
    {
        return planId;
    }
    public void setPlanId(String planId)
    {
        this.planId = planId;
    }
    public String getPlanIdEn()
    {
        return "http://www.xyz.cn/mall/detail-" + planIdEn + ".html";
    }
    public void setPlanIdEn(String planIdEn)
    {
        this.planIdEn = planIdEn;
    }
    public String getName()
    {
        return name;
    }
    public void setName(String name)
    {
        this.name = name;
    }
    public String getShortName()
    {
        return shortName;
    }
    public void setShortName(String shortName)
    {
        this.shortName = shortName;
    }
    public String getType()
    {
        return type;
    }
    public void setType(String type)
    {
        this.type = type;
    }
    public String getKind()
    {
        return kind;
    }
    public void setKind(String kind)
    {
        this.kind = kind;
    }
    public String getSort()
    {
        return sort;
    }
    public void setSort(String sort)
    {
        this.sort = sort;
    }
    public String getInsComId()
    {
        return insComId;
    }
    public void setInsComId(String insComId)
    {
        this.insComId = insComId;
    }
    public String getInsComName()
    {
        return insComName;
    }
    public void setInsComName(String insComName)
    {
        this.insComName = insComName;
    }
    public String getInsComImgUrl()
    {
        return insComImgUrl;
    }
    public void setInsComImgUrl(String insComImgUrl)
    {
        this.insComImgUrl = insComImgUrl;
    }
    public String getForTheCrowd()
    {
        return forTheCrowd;
    }
    public void setForTheCrowd(String forTheCrowd)
    {
        this.forTheCrowd = forTheCrowd;
    }
    public String getMaxLimitCopies()
    {
        return maxLimitCopies;
    }

    public int getMaxLimitCopiesIntValue()
    {
        if (StringUtils.isNull(maxLimitCopies)) {
            return 0;
        }
        return Integer.valueOf(maxLimitCopies);
    }

    public void setMaxLimitCopies(String maxLimitCopies)
    {
        this.maxLimitCopies = maxLimitCopies;
    }
    public ArrayList<String> getPolicyTypes()
    {
        return policyTypes;
    }
    public void setPolicyTypes(ArrayList<String> policyTypes)
    {
        this.policyTypes = policyTypes;
    }
    public String getMarketPrice()
    {
        return marketPrice;
    }
    public void setMarketPrice(String marketPrice)
    {
        this.marketPrice = marketPrice;
    }
    public String getDiscountPrice()
    {
        return discountPrice;
    }
    public void setDiscountPrice(String discountPrice)
    {
        this.discountPrice = discountPrice;
    }
    public String getTailType()
    {
        return tailType;
    }
    public void setTailType(String tailType)
    {
        this.tailType = tailType;
    }
    public String getStatus()
    {
        return status;
    }
    public void setStatus(String status)
    {
        this.status = status;
    }
    public String getImgUrl()
    {
        return imgUrl;
    }
    public void setImgUrl(String imgUrl)
    {
        this.imgUrl = imgUrl;
    }
    public String getLargeUrl()
    {
        return largeUrl;
    }
    public void setLargeUrl(String largeUrl)
    {
        this.largeUrl = largeUrl;
    }
    public String getBigImgUrl()
    {
        return bigImgUrl;
    }
    public void setBigImgUrl(String bigImgUrl)
    {
        this.bigImgUrl = bigImgUrl;
    }
    public String getOutPolicyTime()
    {
        return outPolicyTime;
    }
    public void setOutPolicyTime(String outPolicyTime)
    {
        this.outPolicyTime = outPolicyTime;
    }
    public String getOutPolicyTimeUnit()
    {
        return outPolicyTimeUnit;
    }
    public void setOutPolicyTimeUnit(String outPolicyTimeUnit)
    {
        this.outPolicyTimeUnit = outPolicyTimeUnit;
    }
    public String getFastestActiveTime()
    {
        return fastestActiveTime;
    }
    public void setFastestActiveTime(String fastestActiveTime)
    {
        this.fastestActiveTime = fastestActiveTime;
    }
    public ActiveTimeUnit getFastestActiveTimeUnit()
    {
        return fastestActiveTimeUnit;
    }
    public void setFastestActiveTimeUnit(String fastestActiveTimeUnit)
    {
        this.fastestActiveTimeUnit = ActiveTimeUnit.parse(fastestActiveTimeUnit);
    }
    public String getPlanFeatures()
    {
        return planFeatures;
    }
    public void setPlanFeatures(String planFeatures)
    {
        this.planFeatures = planFeatures;
    }
    public String getPlanReading()
    {
        return planReading==null?"":planReading;
    }
    public void setPlanReading(String planReading)
    {
        this.planReading = planReading;
    }
    public String getUnderwExamples()
    {
        return underwExamples;
    }
    public void setUnderwExamples(String underwExamples)
    {
        this.underwExamples = underwExamples;
    }
    public String getClaimsExamples()
    {
        return claimsExamples;
    }
    public void setClaimsExamples(String claimsExamples)
    {
        this.claimsExamples = claimsExamples;
    }
    public String getNoticeToUnderw()
    {
        return noticeToUnderw;
    }
    public void setNoticeToUnderw(String noticeToUnderw)
    {
        this.noticeToUnderw = noticeToUnderw;
    }
    public ArrayList<String> getCategories()
    {
        return categories;
    }
    public void setCategories(ArrayList<String> categories)
    {
        this.categories = categories;
    }
    public ArrayList<String> getScategories()
    {
        return scategories;
    }
    public void setScategories(ArrayList<String> scategories)
    {
        this.scategories = scategories;
    }
    public ArrayList<String> getTags()
    {
        return tags;
    }
    public void setTags(ArrayList<String> tags)
    {
        this.tags = tags;
    }
    public ArrayList<Clauses> getClauses()
    {
        return clauses;
    }
    public void setClauses(ArrayList<Clauses> clauses)
    {
        this.clauses = clauses;
    }
    public UnderwGender getUnderwGender()
    {
        return underwGender;
    }
    public void setUnderwGender(UnderwGender underwGender)
    {
        this.underwGender = underwGender;
    }
    public UnderwAge getUnderwAge()
    {
        return underwAge;
    }
    public void setUnderwAge(UnderwAge underwAge)
    {
        this.underwAge = underwAge;
    }
    public ArrayList<Province> getUnderwAreas()
    {
        return underwAreas;
    }
    public void setUnderwAreas(ArrayList<String> areas)
    {
        underwAreas = processUnderArea(areas);
    }
    private ArrayList<Province> processUnderArea(ArrayList<String> underAreas)
    {
        ArrayList<Province> areas = AreaManager.getInstance().getProvinces();
        if (underAreas == null || underAreas.size() == 0)
        {
            return null;
        }
        else
        {
            ArrayList<Province> newareas = new ArrayList<Province>();
            for (Province province : areas)
            {
                ArrayList<City> cities = province.getLeaves();
                ArrayList<City> results = new ArrayList<City>();
                if (cities == null || cities.size() == 0)
                {
                    continue;
                }
                for (City city : cities)
                {
                    if (underAreas.contains(city.getCode()))
                    {
                        results.add(city);
                    }
                }
                if (results.size() > 0)
                {
                    Province province2 = new Province();
                    province2.setCode(province.getCode());
                    province2.setName(province.getName());
                    province2.setLeaves(results);
                    newareas.add(province2);
                }
            }
            ArrayList<Province> provinces = newareas.size() == 0 ? null : newareas;
            if(provinces==null&& !XYZSdkUtils.isEmpty(underAreas)){
                return areas;
            }
            return provinces;
        }
    }
    public KeyValues getProtectionPeriod()
    {
        return protectionPeriod;
    }
    public void setProtectionPeriod(KeyValues protectionPeriod)
    {
        this.protectionPeriod = protectionPeriod;
    }
    public ArrayList<String> getTourDestinations()
    {
        return tourDestinations;
    }
    public void setTourDestinations(ArrayList<String> tourDestinations)
    {
        this.tourDestinations = tourDestinations;
    }
    public String getOccupationalLevel()
    {
        return occupationalLevel;
    }
    public void setOccupationalLevel(String occupationalLevel)
    {
        this.occupationalLevel = occupationalLevel;
    }
    public ArrayList<String> getRelationshipToPolicyholders()
    {
        return relationshipToPolicyholders;
    }
    public void setRelationshipToPolicyholders(ArrayList<String> relationshipToPolicyholders)
    {
        this.relationshipToPolicyholders = relationshipToPolicyholders;
    }
    public ArrayList<Benefits> getBenefits()
    {
        return benefits;
    }
    public void setBenefits(ArrayList<Benefits> benefits)
    {
        this.benefits = benefits;
    }
    public boolean isNotUnderwAreaFlag()
    {
        return notUnderwAreaFlag;
    }
    public void setNotUnderwAreaFlag(boolean notUnderwAreaFlag)
    {
        this.notUnderwAreaFlag = notUnderwAreaFlag;
    }
    public boolean isNotUnderwVehiclesFlag()
    {
        return notUnderwVehiclesFlag;
    }
    public void setNotUnderwVehiclesFlag(boolean notUnderwVehiclesFlag)
    {
        this.notUnderwVehiclesFlag = notUnderwVehiclesFlag;
    }
    public boolean isInsuredEnNameFlag()
    {
        return insuredEnNameFlag;
    }
    public void setInsuredEnNameFlag(boolean insuredEnNameFlag)
    {
        this.insuredEnNameFlag = insuredEnNameFlag;
    }
    public String getMaxActiveTime()
    {
        return maxActiveTime;
    }
    public void setMaxActiveTime(String maxActiveTime)
    {
        this.maxActiveTime = maxActiveTime;
    }
    public ActiveTimeUnit getMaxActiveUnit()
    {
        return maxActiveUnit;
    }
    public void setMaxActiveUnit(String maxActiveUnit)
    {
        this.maxActiveUnit = ActiveTimeUnit.parse(maxActiveUnit);
    }
    public String getLastModified()
    {
        return lastModified;
    }
    public void setLastModified(String lastModified)
    {
        this.lastModified = lastModified;
    }
    public boolean isFlightNoFlag()
    {
        return flightNoFlag;
    }
    public void setFlightNoFlag(boolean flightNoFlag)
    {
        this.flightNoFlag = flightNoFlag;
    }
    public ArrayList<ProdPromotionTag> getPromotions()
    {
        return promotions;
    }
    public void setPromotions(ArrayList<ProdPromotionTag> promotions)
    {
        this.promotions = promotions;
    }
    public boolean isNeedHomeTypeFlag()
    {
        return needHomeTypeFlag;
    }
    public void setNeedHomeTypeFlag(boolean needHomeTypeFlag)
    {
        this.needHomeTypeFlag = needHomeTypeFlag;
    }
    public ArrayList<HomeType> getHomeType()
    {
        return homeType;
    }
    public void setHomeType(ArrayList<HomeType> homeType)
    {
        this.homeType = homeType;
    }
    public boolean isNeedHomeProCityFlag()
    {
        return needHomeProCityFlag;
    }
    public void setNeedHomeProCityFlag(boolean needHomeProCityFlag)
    {
        this.needHomeProCityFlag = needHomeProCityFlag;
    }
    public ArrayList<String> getHomeProvince()
    {
        return homeProvince;
    }
    public void setHomeProvince(ArrayList<String> homeProvince)
    {
        this.homeProvince = homeProvince;
    }
    public ArrayList<Province> processHomeProvince()
    {
        ArrayList<Province> areas = AreaManager.getInstance().getProvinces();
        if (homeProvince == null || homeProvince.size() == 0)
        {
            return areas;
        }
        else
        {
            ArrayList<Province> newareas = new ArrayList<Province>();
            for (Province province : areas)
            {
                ArrayList<City> cities = province.getLeaves();
                ArrayList<City> results = new ArrayList<City>();
                if (cities == null || cities.size() == 0)
                {
                    continue;
                }
                for (City city : cities)
                {
                    if (homeProvince.contains(province.getCode()))
                    {
                        results.add(city);
                    }
                }
                if (results.size() > 0)
                {
                    Province province2 = new Province();
                    province2.setCode(province.getCode());
                    province2.setName(province.getName());
                    province2.setLeaves(results);
                    newareas.add(province2);
                }
            }
            return newareas.size() == 0 ? null : newareas;
        }
    }
    public boolean isNeedZipCodeFlag()
    {
        return needZipCodeFlag;
    }
    public void setNeedZipCodeFlag(boolean needZipCodeFlag)
    {
        this.needZipCodeFlag = needZipCodeFlag;
    }
    public boolean isNeedHomeAddressFlag()
    {
        return needHomeAddressFlag;
    }
    public void setNeedHomeAddressFlag(boolean needHomeAddressFlag)
    {
        this.needHomeAddressFlag = needHomeAddressFlag;
    }
    public int getLimitPeopleNum()
    {
        return limitPeopleNum;
    }
    public void setLimitPeopleNum(int limitPeopleNum)
    {
        this.limitPeopleNum = limitPeopleNum;
    }

    public int getMaxAcceptPeopleNum()
    {
        if (limitPeopleNum == 0) {
            return 10;//不限制个数，但移动端限制最多10人
        }else {
            return Math.min(limitPeopleNum, 10);
        }
    }

    public boolean isTrialPrice() {
        return "2".equalsIgnoreCase(getTailType());
    }

    public static boolean judgeIsLiCaiXian(String planID){
        return planID.equals("11096");
    }


}
