package com.xyz.sdk.product.bean.plan;

import android.annotation.SuppressLint;

import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * Created by zhangzheng on 2016/2/23.
 */
public enum ActiveTimeUnit
{
    HOUR("0", Calendar.HOUR_OF_DAY, 1, Calendar.DAY_OF_MONTH, 0, "yyyy-MM-dd HH", "yyyy-MM-dd HH", "yyyy-MM-dd HH"),
    DAY("1", Calendar.DAY_OF_MONTH, 0, Calendar.DAY_OF_MONTH, -1, "yyyy-MM-dd 00", "yyyy-MM-dd 24", "yyyy-MM-dd");

    //最快生效时间单位的对应值
    private String code;
    //开始时间补偿单位（小时、天）
    private int compensateUnit;
    //开始时间补偿值(小时:1，天:0)
    private int compensateValue;
    //结束时间偏移单位(天)
    private int offsetUnit;
    //结束时间偏移值(小时:0，天:-1)
    private int offsetValue;
    //最快生效时间单位对应的时间解析
    private SimpleDateFormat startDateFormat;
    private SimpleDateFormat endDateFormat;

    private SimpleDateFormat maxActiveFormat;


    @SuppressLint("SimpleDateFormat")
    private ActiveTimeUnit(String c, int cu, int cv, int ou, int ov, String strat, String end, String maxActive)
    {
        code = c;
        compensateUnit = cu;
        compensateValue = cv;
        offsetUnit = ou;
        offsetValue = ov;
        startDateFormat = new SimpleDateFormat(strat);
        endDateFormat = new SimpleDateFormat(end);
        maxActiveFormat = new SimpleDateFormat(maxActive);
    }

    public String getCode()
    {
        return code;
    }
    public int getCompensateValue()
    {
        return compensateValue;
    }
    public int getCompensateUnit()
    {
        return compensateUnit;
    }
    public int getOffsetUnit()
    {
        return offsetUnit;
    }
    public int getOffsetValue()
    {
        return offsetValue;
    }
    public SimpleDateFormat getStartDateFormat()
    {
        return startDateFormat;
    }
    public SimpleDateFormat getEndDateFormat()
    {
        return endDateFormat;
    }


    public SimpleDateFormat getMaxActiveFormat() {
        return maxActiveFormat;
    }

    public void setMaxActiveFormat(SimpleDateFormat maxActiveFormat) {
        this.maxActiveFormat = maxActiveFormat;
    }

    public static ActiveTimeUnit parse(String str)
    {
        if("0".equals(str))
        {
            return HOUR;
        }
        else
        {
            return DAY;
        }
    }

    public boolean equals(ActiveTimeUnit unit) {
        return this.code.equals(unit.getCode());
    }
}
